# Overview
This file is a introduction to documentation. The overall documentation is in \documenation\template.pdf

# Installation
To start the application you need to do the following steps:
1. Install Docker and start it
2. Run `docker compose up` command inside the root folder of the project

# File structure
## \api
This folder contains the source code to backend API. 
### \api\serverKeys
This folder contains the RSA generated keys server keys for the backend API.
### \api\testDocuments
Includes example document for encryption and decryption of showcase AES 256 symetric algorithm.
### \api\app.py
This file contains the backend API. It is a Flask application that handles the requests from the frontend and communicates with the database.
### \api\createAsymmetricRSAKey.py
This file is used to generate the RSA keys for the backend API and client.
<hr></hr>

## \client
This folder contains the source code to frontend client developed in React framework.
### \client\clientKeys
This folder contains the RSA generated keys for for the frontend client.
### \client\src
It contains the source code for the frontend client logic.
### \client\src\components
This folder contains the React components for the frontend client that are used to comunicate with the backend API.
### \client\src\components\Crypt.js
This file contains the logic for the encryption and decryption of the database data.
### \client\src\components\CryptFile.js
This file contains the logic for the encryption and decryption of the file's content.
<hr></hr>

## \init-db-scripts
This folder contains the scripts to initialize the database.

## \pythonProject
This is just a playground to test the libraries.

## \documentation
Contains whole documentation files to this project.
