from cryptography.hazmat.primitives.asymmetric import rsa

from cryptography.hazmat.primitives import serialization

def save_key_private(pk, filename):
    pem = pk.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.TraditionalOpenSSL,
        encryption_algorithm=serialization.NoEncryption()
    )
    with open(filename, 'wb') as pem_out:
        pem_out.write(pem)

def save_key_public(pk, filename):
    pem = pk.public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    )
    with open(filename, 'wb') as pem_out:
        pem_out.write(pem)



private_key = rsa.generate_private_key(
    public_exponent=65537,
    key_size=4096,
)

pem = private_key.private_bytes(
   encoding=serialization.Encoding.PEM,
   format=serialization.PrivateFormat.PKCS8,
   encryption_algorithm=serialization.NoEncryption()
)
pem.splitlines()[0]

public_key = private_key.public_key()
pem1 = public_key.public_bytes(
   encoding=serialization.Encoding.PEM,
   format=serialization.PublicFormat.SubjectPublicKeyInfo
)
pem1.splitlines()[0]

save_key_private(private_key,"Private_KEY")
save_key_public(public_key,"Public_KEY")

pepek = 3