import React, {useEffect, useState} from 'react'
import { useLocation } from 'react-router-dom';
import CustomNavbar from './NavBar';
import { Container, Button, Col, Row } from 'react-bootstrap';
// import { Button } from 'react-bootstrap/lib/InputGroup';
var forge = require('node-forge');

export default function UploadKey(props) {
    let location = useLocation();
    const data = location.state; 
   
    
    const [inputProps, setInputProps] = useState(data);
    const [responseMessagePublic, setResponseMessagePublic] = useState("");
    const [responseMessagePrivate, setResponseMessagePrivate] = useState("");
    const [responseMessageSendText, setResponseMessageSendText] = useState("");
    const [inputValuePublic, setInputValuePublic] = useState('');
    const [inputValuePrivate, setInputValuePrivate] = useState('');
    const [privateKey, setprivateKey] = useState("")
    const [sendText, setSendText] = useState("")
    const [isLoadingSendtext, setIsLoadingSendText] = useState(false)
    const [isLoadingPublic, setIsLoadingPublic] = useState(false)
    const [isLoadingPrivate, setIsLoadingPrivate] = useState(false)
    const [dataJson,setDataJson] = useState("empty")
    const [err, setErr] = useState('');
    const [publicKeyServer,setPublicKeyServer] = useState(
      `-----BEGIN PUBLIC KEY-----
      MIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEAxhPA0dEouX2Obuhag9H2
      wh6L/Gj9llKcuCsf3b/ndbRqxLbAYmpCQwYRvhUmb3HYttJ7pHJLoBlO1/i0cM4p
      PaJTMc4mmwX7FB5JgvqvYXl4KRu/TOnmPImZBdaCghnbqKfFK1gFDtmb3eABXoN+
      3Q49qzJqS4akui4H+ZLWKGrjO08XwvMpGE651ZOBMufMkkzUwwN8L2XfLKMJJiEJ
      jVC7ape+Giq1yL4oK9XAXslu9wZ0zlrCdbfueznLJZGo3O2l6bIv6Wj81ZFBJuGh
      s+LQMohTxStnjhmIY74H65ElcO0PlDo8dU5ZTfHf3IVULcrElbRXFFd/N3l3rQ/p
      IWtNLI83gjuiFC05Y8aH3ahK4mVV2UKJXxIeCBHTAvkCKxOsVG780/O51rksBN0c
      EoivUN4N54s94NpaLSSiA2wdvhA4Io9UKXuMrbDu1BsAw2++AJ9j9JGHeWqB40Hr
      zMnMCcO/3KUL7BNJ9xYgJ9dJOAGDOMxZJ43BtQyk+bRg/xzuCJRDoH98jD9c0i+b
      u4OCzEL2MYpFTxkha57I+kK7HhY0layrrRhU1Xn9aWA6w3QvVl+pHqa7d9olZveW
      PWAJvl+3Vqzj7AVRaVlJEI686Hs8+9Tjq6cGH3aY7ZOIoBu9Y2sKGyr48reZe2ig
      dyPh2x3+s58xLfds1iwfgjMCAwEAAQ==
      -----END PUBLIC KEY-----`)

      if (data.privateKey != '' && privateKey == '') {
        setprivateKey(data.privateKey)
      }
      console.log(privateKey)
    
    var publicKey = forge.pki.publicKeyFromPem(publicKeyServer);

    const rsaEncryptString = (data) => {

      var encrypted = publicKey.encrypt(data, 'RSA-OAEP', {
        md: forge.md.sha256.create(),
        mgf1: forge.mgf1.create()
      });
      return forge.util.encode64(encrypted);
    }


    const handleClickPublic = async () => {
        setIsLoadingPublic(true);
        var iskeyvalid = false
        try {

          setResponseMessagePublic("")
          //check if public key is valid
          try {
            var publicKey = forge.pki.publicKeyFromPem(inputValuePublic);
            iskeyvalid = true
          } catch (error) {
          }
          if(!iskeyvalid){
            setResponseMessagePublic("Invalid public key, the key must be in PEM format");
          }
          
          //check if response message is empty
          console.log(responseMessagePublic)
          if(iskeyvalid){
            var tokenEncrypt = rsaEncryptString(inputProps.token)

            const requestOptions = {
              method: 'POST',
              body: JSON.stringify({publicKey: inputValuePublic,
                                    email: inputProps.email,
                                    token: tokenEncrypt}),
            }
            const response = await fetch('http://localhost:5000//api/uploadKey', requestOptions,);
      
            if (!response.ok) {
              throw new Error(`Error! status: ${response.status}`);
            }
            console.log(response)
      
            var result = await response.json();
            result = result.data.message 
    
            if (result === "Public key has been uploaded"){
              setResponseMessagePublic("Public key is valid and set");
            }
          }

        } catch (err) {
          if(result === "Token is not valid"){
            setResponseMessagePublic("Your client token is not valid");
          }
          else if(result === "Token has expired"){
            setResponseMessagePublic("Your token has expired, please login again");
          }else{
            setResponseMessagePublic("Something went wrong, please try again");
          }
          
          console.log(err.message);
          setErr(err.message);
        } finally {
          setIsLoadingPublic(false);
        }
  };

      const handleClickPrivate = () => {
        try {
          //check if private key is valid
          var privateKey = forge.pki.privateKeyFromPem(inputValuePrivate);
          setprivateKey(inputValuePrivate)
          setResponseMessagePrivate("Private key is valid and set");
        } catch (err) {
          setResponseMessagePrivate("Invalid private key, the key must be in PEM format");
          console.log(err.message);
          setErr(err.message);
        } finally {
        }
      };


      const handleClickSendText = async () => {
        setIsLoadingSendText(true);
        try {
          var tokenEncrypt = rsaEncryptString(inputProps.token)
          var sendTextEncrypt = rsaEncryptString(sendText)



          const requestOptions = {
            method: 'POST',
            body: JSON.stringify({email: inputProps.email,
                                  token: tokenEncrypt,
                                  sendText: sendTextEncrypt,
                                }),
          }
          const response = await fetch('http://localhost:5000//api/sendText', requestOptions,);
    
          if (!response.ok) {
            throw new Error(`Error! status: ${response.status}`);
          }
          console.log(response)
    
          var result = await response.json();
          result = result.data.message 

          //decrypt the response
          var prKey = forge.pki.privateKeyFromPem(privateKey);
          var decryptedText = prKey.decrypt(forge.util.decode64(result), 'RSA-OAEP', {
            md: forge.md.sha256.create(),
          });

          console.log(decryptedText)
          setResponseMessageSendText("Text was correctly encrypted and decrypted - " + decryptedText);

        } catch (err) {
          setResponseMessageSendText("Public key is not set or not valid or you did not set private key or you have to login again because of token expiration")
          console.log(err.message);
          setErr(err.message);
        } finally {
          setIsLoadingSendText(false);
        }
  };
  
      useEffect(() => {
        if(dataJson !== "empty"){
  
          
        }
      }, [dataJson])
      
      return (

        <div className='row bg-light text-dark' style={{height: `${document.documentElement.scrollHeight}px`}}>
          <Container>
            <CustomNavbar 
              email={inputProps.email}
              token={inputProps.token}
              privateKey={privateKey != '' ? privateKey : ''}
              />
            <Row style={{marginLeft: '20px'}}>
              <Col className='justify-content-center'>
                <textarea 
                value={inputValuePublic} 
                style={{width: '90%', height: '250px'}} 
                onChange={e => setInputValuePublic(e.target.value)} 
                maxLength="1024"
                placeholder="Max 1024 characters"
                />

                {(typeof responseMessagePublic === "undefined" || responseMessagePublic === "") ? (
                  <p></p>
                ): (
                  <p style={{color: 'red'}}>{responseMessagePublic}</p>
                )}
                <Button variant="primary" disabled={isLoadingPublic} onClick={handleClickPublic} style={{backgroundColor: 'rgb(33,37,41)', color: 'rgb(248, 249, 250)', borderColor: 'rgb(33,37,41)'}}>set public key</Button>
              </Col>
            </Row>
            <Row style={{marginTop: '20px', marginLeft: '20px'}}>
              <Col className='justify-content-center'>
                <textarea 
                value={inputValuePrivate} 
                style={{width: '90%', height: '250px'}} 
                onChange={e => setInputValuePrivate(e.target.value)} 
                maxLength="4096"
                placeholder="Max 4096 characters"
                />

                {(typeof responseMessagePrivate === "undefined" || responseMessagePrivate === "") ? (
                  <p></p>
                ): (
                  <p style={{color: 'red'}}>{responseMessagePrivate}</p>
                )}
                <Button variant="primary" onClick={handleClickPrivate} style={{backgroundColor: 'rgb(33,37,41)', color: 'rgb(248, 249, 250)', borderColor: 'rgb(33,37,41)'}}>set private key</Button>
              </Col>
            </Row>
            <Row style={{marginTop: '20px', marginLeft: '20px'}}>
              <Col className='justify-content-center'>
                <textarea 
                value={sendText}
                onChange={e => setSendText(e.target.value)} 
                maxLength="50"
                placeholder="Max 50 characters"
                />
                {(typeof responseMessageSendText === "undefined" || responseMessageSendText === "") ? (
                  <p></p>
                ): (
                  <p style={{color: 'red'}}>{responseMessageSendText}</p>
                )}
                <Button variant="primary" disabled={isLoadingSendtext} onClick={handleClickSendText} style={{backgroundColor: 'rgb(33,37,41)', color: 'rgb(248, 249, 250)', borderColor: 'rgb(33,37,41)'}}>send Text</Button>
              </Col>
            </Row>
          </Container>
        </div>
      )
}