import React from 'react';
import { Navbar, Nav } from 'react-bootstrap';
import { Link } from 'react-router-dom';
import { BsFillChatLeftTextFill, BsFillFileEarmarkFill ,BsFillCloudArrowUpFill, BsFillHouseFill } from 'react-icons/bs';


function CustomNavbar({email, token, privateKey}) {
    return (
        
        <Navbar className="justify-content-center" bg="light" expand="lg">
            <Navbar.Brand style={{ paddingLeft: '20px' }}
                as={Link} 
                to="/dashboard"
                state = {{email: email, token: token, privateKey: privateKey}}
            >ClockME</Navbar.Brand>
            <Navbar.Toggle aria-controls="basic-navbar-nav" />
            <Navbar.Collapse className="justify-content-center" id="basic-navbar-nav" style={{marginLeft: '10px'}}>
                <Nav className="justify-content-center" variant="tabs" defaultActiveKey="/home">
                    <Nav.Item>
                        <Nav.Link as={Link} 
                        to={"/dashboard"}
                        state = {{email: email, token: token, privateKey: privateKey}}>
                        <BsFillHouseFill/> 
                        <span style={{ marginLeft: '5px' }}>Domov</span>
                        </Nav.Link>
                    </Nav.Item> 
                    <Nav.Item>
                        <Nav.Link as={Link} 
                        to={"/uploadkey"}
                        state = {{email: email, token: token, privateKey: privateKey}}>                        
                        <BsFillCloudArrowUpFill/> 
                        <span style={{ marginLeft: '5px' }}>Kľúče</span>
                        </Nav.Link>
                    </Nav.Item>
                </Nav>
                </Navbar.Collapse>
            
        </Navbar>
    );
};

export default CustomNavbar;