<?php
session_start();    

include_once("./db/config.php");

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)&& (isset($_SESSION["role"]) && $_SESSION["role"]=="admin")) {
    $userEmail = $_SESSION['email'];
} else {
    header("location: login.php");
    exit;
}

if ($_SERVER["REQUEST_METHOD"] == "POST") {

    if (isset($_POST["addRoom"])) {
        echo "pice";
        // Process form data when the form is submitted
        $title = $_POST["title"];
        $description = $_POST["description"];
        $roomNumber = $_POST["room_number"];
        $price = $_POST["price"];
        $bedCount = $_POST["bed_count"];

        // Create the destination directory if it doesn't exist
        $destinationDirectory = 'uploads/photos/';
        if (!file_exists($destinationDirectory)) {
            mkdir($destinationDirectory, 0777, true);
        }


        // Handle main photo upload
        $mainPhoto = handleFileUpload('main_photo', 'uploads/photos/');
        $mainPhotoUrl = $mainPhoto['generated_filename'];
        // $mainPhotoOriginalName = $mainPhoto['original_name'];

        // var_dump($mainPhotoOriginalName);
        var_dump($mainPhotoUrl);


        // Check if the room number already exists
        $checkRoomNumberQuery = "SELECT id FROM rooms WHERE room_number = '$roomNumber'";
        $result = $link->query($checkRoomNumberQuery);

        if ($result->num_rows > 0) {
            echo "<script>alert('Error adding room: Room number already exists.');</script>";
        } else {
            // Insert data into the rooms table
            $insertRoomQuery = "INSERT INTO rooms (title, room_number, price, bed_count, created_at,description, main_photo_url) 
                                VALUES ( '$title', '$roomNumber', '$price', '$bedCount', NOW(), '$description', '$mainPhotoUrl')";

            if ($link->query($insertRoomQuery) === TRUE) {
                $roomId = $link->insert_id; // Get the ID of the inserted catalog entry

                // Handle additional photos upload
                if (!empty($_FILES["additional_photos"]["name"][0])) {
                    $additionalPhotos = handleMultipleFileUpload('additional_photos', 'uploads/photos/');

                    foreach ($additionalPhotos as $photo) {
                        $insertPhotosQuery = "INSERT INTO photos (room_id, photo_url, created_at) 
                                            VALUES ($roomId, '$photo[generated_filename]', NOW())";

                        $link->query($insertPhotosQuery);
                    }
                }

                echo "<script>alert('Room added successfully.');</script>";
            } else {
                echo "<script>alert('Error adding room: " . $link->error . "');</script>";
            }
        }
    }
}

// Function to handle single file upload
function handleFileUpload($inputName, $targetDir) {
    $allowedFileTypes = ['image/jpeg', 'image/png', 'image/gif']; // Add more if needed

    $originalName = basename($_FILES[$inputName]["name"]);
    $generatedFilename = generateUniqueFilename($originalName, $targetDir);
    $targetFile = $targetDir . $generatedFilename;

    $fileType = $_FILES[$inputName]["type"];

    // Check file type
    if (!in_array($fileType, $allowedFileTypes)) {
        die('Invalid file type. Allowed types: ' . implode(', ', $allowedFileTypes));
    }

    move_uploaded_file($_FILES[$inputName]["tmp_name"], $targetFile);

    return ['generated_filename' => $generatedFilename, 'original_name' => $originalName];
}

// Function to handle multiple file uploads
function handleMultipleFileUpload($inputName, $targetDir) {
    $allowedFileTypes = ['image/jpeg', 'image/png', 'image/gif']; // Add more if needed

    $uploadedFiles = [];

    foreach ($_FILES[$inputName]["name"] as $key => $value) {
        $originalName = basename($_FILES[$inputName]["name"][$key]);
        $generatedFilename = generateUniqueFilename($originalName, $targetDir);
        $targetFile = $targetDir . $generatedFilename;

        $fileType = $_FILES[$inputName]["type"][$key];

        // Check file type
        if (!in_array($fileType, $allowedFileTypes)) {
            die('Invalid file type. Allowed types: ' . implode(', ', $allowedFileTypes));
        }

        move_uploaded_file($_FILES[$inputName]["tmp_name"][$key], $targetFile);

        $uploadedFiles[] = ['generated_filename' => $generatedFilename, 'original_name' => $originalName];
    }

    return $uploadedFiles;
}

function generateUniqueFilename($originalName, $targetDir) {
    $extension = pathinfo($originalName, PATHINFO_EXTENSION);
    $basename = pathinfo($originalName, PATHINFO_FILENAME);

    $count = 1;
    $generatedFilename = $basename . '.' . $extension;

    while (file_exists($targetDir . $generatedFilename)) {
        $generatedFilename = $basename . '_' . $count . '.' . $extension;
        $count++;
    }

    return $generatedFilename;
}




?>



<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>

    <link rel="stylesheet" href="style.css">

    <style>
        #drop-area {
            border: 2px dashed #ccc;
            padding: 20px;
            text-align: center;
            cursor: pointer;
        }

        #gallery {
            display: flex;
            flex-wrap: wrap;
        }

        .thumbnail {
            margin: 5px;
            max-width: 150px;
            max-height: 150px;
        }
        .container-sm {
            max-width: 576px; /* Adjust the max-width as needed */
        }
    </style>
</head>

<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>
    <div class="container-sm mt-5">
        <h2 class="mb-4">Add Accommodation</h2>

        <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>" enctype="multipart/form-data">
            <div class="form-group m-1">
                <label for="title">Room Name:</label>
                <input type="text" class="form-control" name="title" required>
            </div>

            <div class="form-group m-1">
                <label for="description">Description:</label>
                <textarea class="form-control" name="description" rows="4" required></textarea>
            </div>

            <div class="form-group m-1">
                <label for="room_number">Room Number:</label>
                <input type="number" class="form-control" name="room_number" min="1" required>
            </div>

            <div class="form-group m-1">
                <label for="price">Price:</label>
                <input type="number" class="form-control" name="price" min="1" required>
            </div>

            <div class="form-group m-1">
                <label for="bed_count">Bed Count:</label>
                <input type="number" class="form-control" name="bed_count" min="1"  required>
            </div>

            <div class="form-group m-1">
                <label for="main_photo">Main Photo:</label>
                <input type="file" class="form-control-file" name="main_photo" accept="image/*" required>
            </div>

            <div id="drop-area" class="form-group m-1">
                <label for="additional_photos">Additional Photos:</label>
                <input type="file" class="form-control-file" name="additional_photos[]" id="fileInput" multiple accept="image/*">
            </div>

            <div id="gallery"></div>

            <button type="submit" class="btn btn-primary mt-3" name="addRoom">Add Room</button>
        </form>
    </div>



</body>

<script>
        const dropArea = document.getElementById("drop-area");
        const fileInput = document.getElementById("fileInput");
        const gallery = document.getElementById("gallery");

        dropArea.addEventListener("dragover", (e) => {
            e.preventDefault();
            dropArea.classList.add("active");
        });

        dropArea.addEventListener("dragleave", () => {
            dropArea.classList.remove("active");
        });

        dropArea.addEventListener("drop", (e) => {
            e.preventDefault();
            dropArea.classList.remove("active");

            const files = e.dataTransfer.files;

            displayPhotos(files);
        });

        fileInput.addEventListener("change", () => {
            const files = fileInput.files;

            displayPhotos(files);
        });

        function displayPhotos(files) {
            gallery.innerHTML = "";

            for (const file of files) {
                const thumbnail = document.createElement("img");
                thumbnail.classList.add("thumbnail");
                thumbnail.src = URL.createObjectURL(file);
                gallery.appendChild(thumbnail);
            }
        }
    </script>

</html>