<?php
session_start();

include_once("./db/config.php");

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)&& (isset($_SESSION["role"]) && $_SESSION["role"]=="admin")) {
    $userEmail = $_SESSION['email'];
} else {
    header("location: login.php");
    exit;
}


// Check if a search query is present in the URL
if (isset($_GET['search'])) {
    $search = $_GET['search'];

    // Modify your SQL query to include the search condition
    $searchQuery = "SELECT * FROM rooms WHERE title LIKE '%$search%' OR description LIKE '%$search%'";
    $rooms = $link->query($searchQuery);

    // // Fetch and display the search results
    // while ($room = $result->fetch_assoc()) {
    //     // Display room information as needed
    //     echo '<div>';
    //     echo '<h3>' . htmlspecialchars($room['title']) . '</h3>';
    //     echo '<p>' . htmlspecialchars($room['description']) . '</p>';
    //     // ... (other room information)
    //     echo '</div>';
    // }
} else {
    // Fetch room information
    $roomQuery = "SELECT * FROM rooms";
    $result = $link->query($roomQuery);
    $rooms = $result->fetch_all(MYSQLI_ASSOC);
}

// Function to truncate text and add three dots
function truncateText($text, $maxLength) {
    if (strlen($text) > $maxLength) {
        $truncatedText = substr($text, 0, $maxLength) . '...';
    } else {
        $truncatedText = $text;
    }

    return $truncatedText;
}



?>

<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Dashboard</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>

    <link rel="stylesheet" href="style.css">
    <style>
        .cropped-img {
            object-fit: cover;
            width: 100%;
            height: 200px; /* Set your desired height */
            transition: transform 0.3s ease-in-out;

        }

        .card:hover .cropped-img {
            transform: scale(1.05);
        }

        .card {
            height: auto; /* Set a fixed height for all cards */
        }
        .card-body, .card-footer{
            padding: 0;
        }
        .btn{
            width: 100%;
        }
        .card-info{
            padding: 1%;
        }
    </style>

</head>

<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>

    <div class="container mt-5">
        <h2 class="mb-4">Dashboard</h2>

        <!-- Add this code where you want to display the search box in your dashboard -->
        <div style="text-align: center; max-width: 400px; margin: 0 auto; padding: 20px; ">
            <form method="get" action="dashboard.php">
                <div class="input-group mb-3" style="display: flex; text-align: center; justify-content: center; max-width: 400px; margin: 0 auto; padding: 20px;align-items: baseline;">
                    <input class="form-control m-2" type="text" placeholder="Search for rooms..." name="search" aria-label="search-button" style="border-radius: 16px">
                    <button class="btn btn-outline-secondary" type="submit" id="search-button" style="border-radius: 16px; max-width: 100px;">Search</button>
                </div>
            </form>
        </div>

        <div class="row">
            <?php foreach ($rooms as $room) : ?>
                <div class="col-md-4 mb-4">
                    <div class="card">

                        <div class="overflow-hidden">
                            <?php
                            $imagePath = "uploads/photos/{$room['main_photo_url']}";
                            $defaultImagePath = "uploads/photos/unknown.png"; // Set the correct path to your default image

                            // Check if the image file exists
                            if (file_exists($imagePath) && $room['main_photo_url'] != '') {
                                echo "<img src='{$imagePath}' class='card-img-top cropped-img' alt='Room Photo'>";
                            } else {
                                echo "<img src='{$defaultImagePath}' class='card-img-top cropped-img' alt='Default Photo'>";
                            }
                            ?>
                        </div>

                        <div class="card-body">
                            <div class="card-info">
                                <h5 class="card-title"><?php echo $room['title']; ?></h5>
                                <?php
                                echo empty($room['description']) ? "Description will be added soon" : truncateText($room['description'], 45);
                                ?>
                            </div>
                        </div>

                        <ul class="list-group list-group-flush">
                            <li class="list-group-item">Room Number: <?php echo $room['room_number']; ?></li>
                            <li class="list-group-item">Price: <?php echo $room['price']; ?> EUR</li>
                            <li class="list-group-item">Bed Count: <?php echo $room['bed_count']; ?></li>
                        </ul>

                        <div class="card-body">
                            <a href="..reservation/room_details.php?roomSelection=<?php echo $room['id']; ?>" class="btn btn-primary">View Details</a>
                        </div>
                              <!-- Edit button -->
                        <div class="card-footer">
                            <a href="editRoom.php?roomSelection=<?php echo $room['id']; ?>" class="btn btn-secondary">Edit Room</a>
                        </div>
                    </div>
                </div>
            <?php endforeach; ?>
        </div>
    </div>


</body>

</html>
