<?php

// Load the recipient's private key from a file (usually in PEM format) and provide the passphrase if protected
// $privateKey = openssl_pkey_get_private(file_get_contents('private.pem'));

$privateKey = file_get_contents('private.pem');

$pattern = '/-----BEGIN PRIVATE KEY-----(.*?)-----END PRIVATE KEY-----/s';

// var_dump($privateKey);

// Use preg_match to find the content between the delimiters
if (preg_match($pattern, $privateKey, $matches)) {
    // $matches[1] will contain the content between the delimiters
    $extractedKey = $matches[1];
} else {
    echo "No public key found in the file.";
}

// var_dump($extractedKey);

// $base64PublicKey = str_replace(' ', '+', $extractedKey);
$base64PublicKey=$extractedKey;
// Decode the base64-encoded string
$binaryPrivateKey = base64_decode($base64PublicKey);

// Create the PEM-formatted public key
$pk = "-----BEGIN RSA PRIVATE KEY-----\n" .
chunk_split(base64_encode($binaryPrivateKey), 64, "\n") .
"-----END RSA PRIVATE KEY-----\n";

$privateKey2 = openssl_pkey_get_private($pk);

//var_dump($pk);
// var_dump($privateKey2);



// Load the encrypted symmetric key
$encryptedSymmetricKey = file_get_contents('encrypted_symmetric_key.dat');

// Decrypt the symmetric key using the recipient's private key
if (openssl_private_decrypt($encryptedSymmetricKey, $decryptedSymmetricKey, $privateKey2, OPENSSL_PKCS1_PADDING) === false) {
    die('Decryption of the symmetric key failed.');
}

// Load the encrypted data
$encryptedData = file_get_contents('encrypted_data.dat');

// Extract the IV (the first 16 bytes) from the encrypted data
$iv = substr($encryptedData, 0, 16);

// Remove the IV from the data
$encryptedData = substr($encryptedData, 16);

// Decrypt the test data using the decrypted symmetric key
$decryptedData = openssl_decrypt($encryptedData, 'aes-256-cbc', $decryptedSymmetricKey, 0, $iv);

// Calculate the hash of the decrypted data for integrity check
$decryptedDataHash = hash('sha256', $decryptedData);

// Load the original hash
$originalHash = file_get_contents('original_hash.txt');

// Load the encrypted data hash
$encryptedDataHash = file_get_contents('encrypted_data_hash.txt');

// Compare the original hash with the hash of the decrypted data
if ($originalHash !== $decryptedDataHash) {
    die('Integrity check failed');
}

var_dump($decryptedData);