<?php
session_start();
if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"])) {
    if( $_SESSION["pubKey"] === null) {
        header("location: index.php");
        exit; 
    }
}else{
    header("location: login.php");
    exit;
}
  
// Load the document to encrypt
$testData = file_get_contents('document.json');

$pubKey = file_get_contents('public.pem');

// Calculate the hash of the original data for integrity check
$originalHash = hash('sha256', $testData);

// Generate a random symmetric key (AES-256 in this example)
$symmetricKey = openssl_random_pseudo_bytes(32);

// Define the encryption cipher
$cipher_algo = 'aes-256-cbc';

// Generate a random initialization vector (IV)
$iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length($cipher_algo));

// Encrypt the test data using the symmetric key
$encryptedData = openssl_encrypt($testData, 'aes-256-cbc', $symmetricKey, 0, $iv);

// Combine IV and encrypted data into a single string
$ivAndData = $iv . $encryptedData;

// Calculate the hash of the encrypted data for integrity check
$encryptedDataHash = hash('sha256', $ivAndData);

// Save the original hash to a file
file_put_contents('original_hash.txt', $originalHash);

// Save the encrypted data hash to a file
file_put_contents('encrypted_data_hash.txt', $encryptedDataHash);

// Save the encrypted data to a file
file_put_contents('encrypted_data.dat', $ivAndData);

// Save the symmetric key securely (e.g., in a separate file)
file_put_contents('symmetric_key.dat', $symmetricKey);

$base64PublicKey = str_replace(' ', '+', $_SESSION["pubKey"]);
//var_dump($_SESSION["pubKey"]);
//var_dump($base64PublicKey);

// Decode the base64-encoded string
$binaryPublicKey = base64_decode($base64PublicKey);

// Create the PEM-formatted public key
$pbk = "-----BEGIN PUBLIC KEY-----\n" .
chunk_split(base64_encode($binaryPublicKey), 64, "\n") .
"-----END PUBLIC KEY-----\n";

// Load the recipient's public key from a file (usually in PEM format)
$publicKey = openssl_pkey_get_public($pbk);

// var_dump($_SESSION["pubKey"]);
// var_dump($pbk);



$pbk2 = "-----BEGIN PUBLIC KEY-----\n";
$pbk2 .= chunk_split(base64_encode($pubKey), 64, "\n");
$pbk2 .= "-----END PUBLIC KEY-----\n";


// var_dump($pubKey);

?>
<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>

    <link rel="stylesheet" href="style.css">
</head>

<body class="d-flex flex-column min-vh-100">
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark mb-2">
        <div class="container">
            <a class="navbar-brand" href="#">Zadanie 1</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="index.php">Home</a>
                    </li>
					<li class="nav-item">
						<?php
                        $userEmail = $_SESSION['email'];
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="#">Welcome, ' . $userEmail . '</a>';
						} else {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="logout.php">Log Out</a>';
						}
						?>
					</li>

                </ul>
            </div>
        </div>
    </nav>
    <!-- Rest of your index.php content -->
    <div>
        <?php
        // Encrypt the symmetric key using the recipient's public key
        if (openssl_public_encrypt($symmetricKey, $encryptedSymmetricKey, $publicKey, OPENSSL_PKCS1_PADDING) === false) {
            die('Encryption of the symmetric key failed.'.$pbk);
        }

        // Save the encrypted symmetric key to a file
        file_put_contents('encrypted_symmetric_key.dat', $encryptedSymmetricKey);

        echo 'Encryption successful.';?>
    </div>
</body>
</html>