<?php
function encryptData($symmetricKey, $pubKey,$data){
    // Calculate the hash of the original data for integrity check
    $originalHash = hash('sha256', $data);
                
    // Define the encryption cipher
    $cipher_algo = 'aes-256-cbc';

    // Generate a random initialization vector (IV)
    $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length($cipher_algo));

    // Encrypt the test data using the symmetric key
    $encryptedData = openssl_encrypt($data, 'aes-256-cbc', $symmetricKey, 0, $iv);

    // Combine IV and encrypted data into a single string
    $ivAndData = $iv . $encryptedData;

    // Calculate the hash of the encrypted data for integrity check
    $encryptedDataHash = hash('sha256', $ivAndData);
                
    // Save the encrypted data to a file
    file_put_contents('encrypted_data.dat',  base64_encode($ivAndData));
    $base64PublicKey = str_replace(' ', '+', $pubKey);
    // Decode the base64-encoded string
    $binaryPublicKey = base64_decode($base64PublicKey);

    // Create the PEM-formatted public key
    $pbk = "-----BEGIN PUBLIC KEY-----\n" .
    chunk_split(base64_encode($binaryPublicKey), 64, "\n") .
    "-----END PUBLIC KEY-----\n";

    // Load the recipient's public key from a file (usually in PEM format)
    $publicKey = openssl_pkey_get_public($pbk);

    // Encrypt the symmetric key using the recipient's public key
    if (openssl_public_encrypt($symmetricKey, $encryptedSymmetricKey, $publicKey, OPENSSL_PKCS1_PADDING) === false) {
        die('Encryption of the symmetric key failed.'.$pbk);
    }
    return  $ivAndData;
}

?>