<?php
include_once("./db/config.php");
session_start();

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)) {
	$userEmail = $_SESSION['email'];
  }else{
    header("location: login.php");
    exit;
}



?>

<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
    <link rel="stylesheet" type="text/css" href="../css/styles.css">

</head>

<!-- <body class="d-flex flex-column min-vh-100"> -->
<body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>
    <!-- Rest of your index.php content -->



    <div id="index-bg">
        <h1 class="centered" id="homeText" >Hotel Tatry</h1>
    </div>

    <div class="container-my my-pd-0">

        <article>
            <h2>O Nás</h2>


            <p>Víta vás Hotel Tatry – Vaša brána do nebeskej pohody v srdci majestátnych Vysokých Tatier! Naša päťhviezdičková oáza luxusu a relaxu vás pozýva objaviť krásy horského raja spojené s prvotriednym pohodlím.</p>

            <p>Nachádzame sa v jedinečnom horskom prostredí, kde sa stretávajú vysoké vrcholy Tatier s eleganciou nášho hotela. Už pri príchode vás uvíta čerstvý horský vzduch, ktorý nesie vôňu borovíc a vám okamžite odľahčí dušu. Sme hrdí na to, že sme vytvorili útočisko, kde sa každý návštevník cíti ako doma, no zároveň je obklopený luxusom a nespočetnými možnosťami na oddych a aktivity.</p>

            <p>Náš hotel disponuje niekoľkými bazénmi, ktoré vám umožnia ponořiť sa do klidu a harmonie. Voda v bazénoch sa líniovaním odráža krásou okolitej prírody a ponúka výhľad na nádherné panorámy, ktoré zdobí najvyšší vrchol Vysokých Tatier. Po dni strávenom na horských chodníkoch alebo lyžovačke si môžete dopriať regeneračné chvíle v našom wellness centre, kde oddych a relax dosahujú úplne nový význam.</p>

            <p>Naši kuchári majú jediný cieľ – potešiť vaše chuťové poháriky. V našich reštauráciách ponúkame špičkovú gastronómiu, ktorá spojuje lokálne chute s medzinárodnými vplyvmi. Každý pokrm je umenie samé osebe, a každý jeden host vstupuje do jedinečnej kulinárskej cesty plnej prekvapení.</p>

            <p>Pre tých, ktorí túžia po dobrodružstve, sme ideálnym východiskom pre výpravy do okolitých hôr. Náš hotel sa nachádza v blízkosti najkrajších turistických chodníkov a lyžiarskych stredísk, čo umožňuje našim hosťom využiť všetky radosti, ktoré horské prostredie Vysokých Tatier ponúka.</p>

            <p>V Hotel Tatry prežijete dovolenku, o ktorej ste vždy snívali – spojenie pohody a luxusu v náručí nezabudnuteľného horského krajiny. Čakáme na vás, aby sme s vami zdieľali túto nezabudnuteľnú cestu. Vstaňte zo siedmeho neba a ponorte sa do pohostinnosti Hotelu Tatry!</p>

        </article>
    </div>

    <div class="button-container">
        <a href="./reservation/create_reservation.php" class="button-28" type="button" >BOOK ROOM</a>
    </div>

    <div id="paralax"></div>



    <div class="container-my mt-3" style="padding-bottom: 0">
        <h2>Rooms</h2>
    </div>

    <div id="my-gallery">
        <div class="row">

            <a href="#" >
                <img src="../uploads/web/room1.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
            <a href="#">
                <img src="../uploads/web/room2.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
            <a href="#">
                <img src="../uploads/web/room3.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
            <a href="#">
                <img src="../uploads/web/room4.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
            <a href="#">
                <img src="../uploads/web/room5.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
            <a href="#">
                <img src="../uploads/web/room6.JPG" alt="Foto Izby hotela" class="cropped-img ">
            </a>
        </div>

    </div>



    <footer>
        <p>©2022</p>
    </footer>


</body>
</html>

