let element = document.getElementById("loadFileButton");
if(element){
    element.addEventListener("click", function () {
        // Get the input element for file selection
        var fileInput = document.getElementById("fileInput");

        if (fileInput.files.length == 1) {
            var selectedFile = fileInput.files[0];
            var reader = new FileReader();
            reader.onload = function (event) {
                // Handle the file content when it's loaded
                var fileContent = event.target.result;
                fetch("./serverUpload/uploadFile.php", {
                    method: "POST",
                    headers: {
                        "Content-Type": "application/x-www-form-urlencoded",
                    },
                    body: "data=" + fileContent,
                }).then(response => response.text())
                .then(data => {
                    document.getElementById("response").textContent = data;
                    document.getElementById("savePubKey").remove();
                })
                .catch(error => {
                    console.error("Error: " + error);
                });
            };

            // Read the file as text (other options include 'readAsDataURL', 'readAsArrayBuffer', etc.)
            reader.readAsText(selectedFile);
        } else {
            alert("Please select a file first.");
        }
    });
}
let element2 = document.getElementById("generateKeys");

if(element2){
    element2.addEventListener("click", function () {
        fetch("./serverUpload/generateKeys.php", {
            method: "POST",
            headers: {
                "Content-Type": "application/x-www-form-urlencoded",
            },
        }).then(response => response.text())
        .then(data => {
           // Update the response to indicate success
            let textNode = document.createElement("p");
            textNode.textContent = "Keys have been successfully generated.";
            document.getElementById("response").appendChild(textNode);

            // Create a Blob from the data
            let blob = new Blob([data], { type: 'text/plain' });

            // Create a new 'a' element for download
            let downloadLink = document.createElement('a');
			downloadLink.setAttribute('id', 'download-link');
            downloadLink.href = window.URL.createObjectURL(blob);
            downloadLink.download = 'private.pem';
            downloadLink.textContent = 'Download Private Key';

            // Append the download link to the document
            document.getElementById("response").appendChild(downloadLink);

            // Automatically trigger the download
            downloadLink.click();

            // Optionally, remove the save public key button if it exists
            let savePubKeyButton =  document.getElementById("savePubKey");
            if (savePubKeyButton) savePubKeyButton.remove();
        })
        .catch(error => {
            console.error("Error: " + error);
        });
    });
}
