<?php
session_start();
require_once('../user/auth.php');
include_once("../db/config.php");

ob_start();

if (isAuth() == 0) {
    header('Location: ../login.php');
    exit;
}

$userId = getUserId();
	$userEmail = $_SESSION['email'];

	$today = date("Y-m-d");
	$rooms = array();

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)) {
    $userEmail = $_SESSION['email'];
} else {
    header("location: login.php");
    exit;
}

if (isset($_GET['roomSelection'])) {
    $roomId = $_GET['roomSelection'];
    
    // Fetch room information
    $roomQuery = "SELECT * FROM rooms WHERE id = $roomId";
    $result = $link->query($roomQuery);
    $room = $result->fetch_assoc();
} else {
    // Redirect to the dashboard if room_id is not provided
    header("location: dashboard.php");
    exit;
}


if (isset($_GET['arrivalDate']) && isset($_GET['departureDate']) && isset($_GET['roomSelection']) && isset($_GET['submit-res'])) {
    echo "ano";
    $roomSelection = $_GET['roomSelection'];
    $roomSelection = mysqli_real_escape_string($link, $roomSelection);
    $arrivalDate=$_GET['arrivalDate'];
    $departureDate=$_GET['departureDate'];


    // Check if room is available within given date range
    $sql = "SELECT * FROM rooms
            WHERE id = '$roomSelection' AND id NOT IN
            (SELECT room_id FROM reservations WHERE (arrival_date <= '$arrivalDate' AND departure_date >= '$arrivalDate') OR (arrival_date <= '$departureDate' AND departure_date >= '$departureDate'))";

    $result = mysqli_query($link, $sql);

    if (mysqli_num_rows($result) == 0) {
        echo "Room is not available for given date range";
        return;
    }


    // Get total price for reservation based on room price and number of days
    $sql = "SELECT * FROM rooms WHERE id = '$roomSelection'";
    $result = mysqli_query($link, $sql);
    $row = mysqli_fetch_assoc($result);
    $price = $row['price'];
    $days = (strtotime($departureDate) - strtotime($arrivalDate)) / (60 * 60 * 24);
    $totalPrice = $price * $days;

    // Create reservation
    $sql = "INSERT INTO reservations (user_id, room_id, arrival_date, departure_date) VALUES ('$userId', '$roomSelection', '$arrivalDate', '$departureDate')";
    $result = mysqli_query($link, $sql);
    if ($result) {
        echo "Reservation created";


        // Get the ID of the last inserted reservation
        $reservationId = mysqli_insert_id($link);

        // Create payment
        $sql = "INSERT INTO payments (reservation_id, amount, paid) VALUES ($reservationId, '$totalPrice', 0)";
        $result = mysqli_query($link, $sql);

        if (!$result || mysqli_affected_rows($link) == 0) {
            echo "Error creating payment";
        } else {
            // Redirect to payment gateway
            header('Location: ../payment-gateway/index.php?reservation_id=' . $reservationId . '&amount=' . $totalPrice);
            exit();
        }
    } else {
        echo "Error creating reservation";
    }
}

// Add your booking logic here

// Function to truncate text and add three dots
function truncateText($text, $maxLength) {
    if (strlen($text) > $maxLength) {
        $truncatedText = substr($text, 0, $maxLength) . '...';
    } else {
        $truncatedText = $text;
    }

    return $truncatedText;
}

?>
<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Dashboard</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>

        <!-- Include Lightbox2 CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/css/lightbox.min.css">

    <!-- Include jQuery (required for Lightbox2) -->
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>

    <!-- Include Lightbox2 JS -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/js/lightbox.min.js"></script>


    <link rel="stylesheet" href="style.css">
    <style>
        .cropped-img {
            object-fit: cover;
            width: 100%;
            height: 200px; /* Set your desired height */
            transition: transform 0.3s ease-in-out;

        }
        
        .card:hover .cropped-img {
            transform: scale(1.05);
        }
        
        .card {
            height: auto; /* Set a fixed height for all cards */
            margin-bottom: 20px;
        }

        .rounded-cropped {
            object-fit: cover;
            width: 100%;
            height: 160px; /* Set your desired height */
        }

    </style>

</head>

<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>
    <div class="container mt-5">
        <h2 class="mb-4">Room Details</h2>

        <div class="row">
            <div class="col-md-8">
                <div class="card">
                    <!-- Display room details here -->
                    <div class="card-body">
                        <h5 class="card-title"><?php echo $room['title']; ?></h5>
                        <p class="card-text"><?php echo $room['description']; ?></p>
                        <ul class="list-group list-group-flush">
                            <li class="list-group-item">Room Number: <?php echo $room['room_number']; ?></li>
                            <li class="list-group-item">Price: <?php echo $room['price']; ?> EUR</li>
                            <li class="list-group-item">Bed Count: <?php echo $room['bed_count']; ?></li>
                            <!-- <button type="submit" class="btn btn-primary">Create Reservation</button> -->

                            <!-- <input class="form-control m-2" type="hidden" name="submit-res" aria-label="submit-res" style="border-radius: 16px"> -->               

                        </ul>
                        <!-- Display additional photos, if available -->
                        <?php
                            $additionalPhotosQuery = "SELECT photo_url FROM photos WHERE room_id = " . $room['id'];
                            $result = $link->query($additionalPhotosQuery);
                            $additionalPhotos = $result->fetch_all(MYSQLI_ASSOC);

                            if (!empty($additionalPhotos)) {
                                echo '<div class="card-body">';
                                echo '<h5 class="card-title">Additional Photos</h5>';
                                echo '<div class="row">';
                                foreach ($additionalPhotos as $photo) {
                                    echo '<div class="col-md-4 mb-3">';
                                    echo '<a href="uploads/photos/' . $photo['photo_url'] . '" data-lightbox="additional-photos" data-title="Additional Photo">';
                                    echo '<img src="uploads/photos/' . $photo['photo_url'] . '" class="img-fluid rounded-cropped" alt="Additional Photo">';
                                    echo '</a>';
                                    echo '</div>';
                                }
                                echo '</div>';
                                echo '</div>';
                            }
                        ?>


                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- ... (your existing scripts and closing tags) ... -->

</body>

<script>
    document.getElementById('run-script').addEventListener('click', function() {
        // Get the values from the URL

        console.log("click");
        var arrivalDate = getParameterByName('arrivalDate');
        var departureDate = getParameterByName('departureDate');
        var roomSelection = getParameterByName('roomSelection');

        // Make an AJAX request to the PHP script
        var url = 'room_details.php?arrivalDate=' + arrivalDate +
                  '&departureDate=' + departureDate +
                  '&roomSelection=' + roomSelection +
                  '&submit-res=true';

        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);

        xhr.onload = function() {
            if (xhr.status === 200) {
                console.log(xhr.responseText);
                // Handle the response as needed
            } else {
                console.error('AJAX Error:', xhr.statusText);
            }
        };

        xhr.onerror = function() {
            console.error('Network Error');
        };

        xhr.send();
    });

    // Function to extract a parameter from the URL
    function getParameterByName(name) {
        var url = window.location.href;
        name = name.replace(/[\[\]]/g, "\\$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
            results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace(/\+/g, " "));
    }
</script>

</html>
