<?php
	require_once('../db/config.php');
	require_once('../user/auth.php');
	session_start();

	if (isAuth() == 0) {
		header('Location: ../login.php');
		exit;
	}

	$userId = getUserId();
	$userEmail = $_SESSION['email'];
	$review_id = $_GET['review_id'];
	$review_id = mysqli_real_escape_string($link, $review_id);

	// Get review from the database using mysqli
	$sql = "SELECT reviews.id as id, reviews.stars as stars, reviews.review as review, reviews.created_at as created_at
			FROM reviews
			WHERE reviews.id = $review_id";

	$result = mysqli_query($link, $sql) or die(mysqli_error($link));
	$review = mysqli_fetch_assoc($result);

	if (!$review) {
		header('Location: /user/reservations');
		exit;
	}
?>


<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
	<script src="https://unpkg.com/@popperjs/core@2"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
</head>
<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>


	<div class='container'>
		<h3>Vaša recenzia</h3>
		<div>
			<span class='d-block'>
				Hodnotenie: <?php echo $review['stars']; ?>
			</span>
			<span class='d-block'>
				Recenzia: <?php echo $review['review']; ?>
			</span>
		</div>
	</div>
</body>

