<?php
	require_once('../db/config.php');
	require_once('../user/auth.php');
	session_start();

	if (isAuth() == 0) {
		header('Location: ../login.php');
		exit;
	}
	$userEmail = $_SESSION['email'];
	$userId = getUserId();

	$reservation_id = $_GET['reservation_id'];
	$reservation_id = mysqli_real_escape_string($link, $reservation_id);

	// Check if the user is the owner of the reservation
	$sql = "SELECT user_id FROM reservations WHERE id = $reservation_id";
	$result = mysqli_query($link, $sql) or die(mysqli_error($link));

	if (mysqli_num_rows($result) > 0) {
		$row = mysqli_fetch_assoc($result);
		if ($row['user_id'] != $userId) {
			header('Location: ../index.php');
			exit;
		}
	}
	else {
		header('Location: ../index.php');
		exit;
	}


	// Save the review to the database using mysqli
	if ($_SERVER["REQUEST_METHOD"] == "POST") {
		$stars = $_POST['rating'];
		$review = $_POST['comment'];

		$sql = "INSERT INTO reviews (user_id, reservation_id, stars, review) VALUES (?, ?, ?, ?)";
		$stmt = mysqli_prepare($link, $sql);

		if ($stmt) {
			mysqli_stmt_bind_param($stmt, "iiis", $userId, $reservation_id, $stars, $review);
			if (mysqli_stmt_execute($stmt)) {
				header('Location: ../index.php');
				exit;
			}
			else {
				echo "Error: " . mysqli_error($link);
			}
		}
		else {
			echo "Error: " . mysqli_error($link);
		}
	}


	function deleteReservation($id, $link) {
		// Delete reservation from the database using mysqli
		$sql = "DELETE FROM reservations WHERE id = $id";
		$result = mysqli_query($link, $sql);
		if ($result) {
			echo "Reservation deleted successfully";
		}
		else {
			echo "Error deleting reservation: " . mysqli_error($link);
		}
	}
?>


<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
	<script src="https://unpkg.com/@popperjs/core@2"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
</head>
<style>
	td {
		vertical-align: middle;
	}
</style>
<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>
	<div class='container'>
		 <h3>Napísať recenziu</h3>
		<form method="post">
			<div class="mb-3">
				<label for="rating" class="form-label">Hodnotenie</label>
				<select class="form-select" id="rating" name="rating" required>
					<option value="">Vyberte hodnotenie</option>
					<option value="1">1</option>
					<option value="2">2</option>
					<option value="3">3</option>
					<option value="4">4</option>
					<option value="5">5</option>
				</select>
			</div>
			<div class="mb-3">
				<label for="comment" class="form-label">Komentár</label>
				<textarea class="form-control" id="comment" name="comment" rows="3" required></textarea>
			</div>
			<button type="submit" class="btn btn-primary">Odoslať recenziu</button>
		</form>
	</div>
</body>

