<?php
include_once("../db/config.php");
session_start();

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)) {
	$userEmail = $_SESSION['email'];

    if ($_SERVER["REQUEST_METHOD"] === "POST") {
        $config = array(
            "digest_alg" => "sha512",
            "private_key_bits" => 2048,
            "private_key_type" => OPENSSL_KEYTYPE_RSA,
        );

        // Generate a private key
        $privateKey = openssl_pkey_new($config);

        // Extract and save the private key
        openssl_pkey_export($privateKey, $privateKeyPEM);

        // Extract and save the public key
        $publicKey = openssl_pkey_get_details($privateKey)["key"];




        // var_dump($publicKey);
        // var_dump($privateKey);
        file_put_contents("../private.pem", $privateKeyPEM);

        // Define a regular expression pattern to match the content between the delimiters
        $pattern = '/-----BEGIN PUBLIC KEY-----(.*?)-----END PUBLIC KEY-----/s';

        // Use preg_match to find the content between the delimiters
        if (preg_match($pattern, $publicKey, $matches)) {
            // $matches[1] will contain the content between the delimiters
            $extractedKey = $matches[1];
        } else {
            $extractedKey = $publicKey;
        }
       
        $sql = "UPDATE users SET public_key = ? WHERE email = ?";
        $stmt = $link->prepare($sql);

        if ($stmt) {
            $stmt->bind_param("ss", $extractedKey, $userEmail); // "ss" indicates two string parameters

            if ($stmt->execute()) {
                echo $privateKeyPEM;
                $_SESSION["pubKey"] = $extractedKey;

            } else {
                echo "Error executing statement: " . $stmt->error;
            }

            $stmt->close();
        } else {
            echo "Error preparing statement: " . $link->error;
        }
    } else {
        echo "No data received in PHP.";
    }
  }else{
    header("location: login.php");
    exit;
}
?>
