<?php
include_once("../db/config.php");
session_start();

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)) {
	$userEmail = $_SESSION['email'];
  }else{
    header("location: login.php");
    exit;
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>

  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
  <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/forge/1.3.1/forge.min.js" integrity="sha512-95iy0RZIbw3H/FgfAj2wnCQJlzFQ+eaSfUeV/l8WVyGHKSRMzm3M/O+85j9ba/HFphkijrCTDjcuDX0BL2lthA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

  <link rel="stylesheet" href="style.css">
</head>



<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#">Zadanie 1</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="./user/reservations.php">My reservations</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="encrypt.php">Encrypt</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="decrypt.php">Decrypt</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="userCreateKey.php">Welcome, ' . $userEmail . '</a>';
						} else {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="logout.php">Log Out</a>';
						}
						?>
					</li>

                </ul>
            </div>
        </div>
    </nav>

  <div class="container-md ">
    
    <h1>Client-Side Decryption</h1>
    <label for="privateKey">Load your private key</label>
    <input type="file" id="privateKey">
    <label for="encyptedFile">Load your private key</label>
    <input type="file" id="encyptedFile">
    <button id="loadsFiels">Load File</button>
  </div>
        
<script>
  let element = document.getElementById("loadsFiels");
  if(element){
      element.addEventListener("click", function () {
          // Get the input element for file selection
          var privateKeyDom = document.getElementById("privateKey");
          var encryptedDataDom = document.getElementById("encyptedFile");
          if (privateKeyDom.files.length == 1 && encryptedDataDom.files.length == 1) {
              var privateKeyFile = privateKeyDom.files[0];
              var encryptedDatFile = encryptedDataDom.files[0];
             
              var readerPrivateKey = new FileReader();
              var readerEncryptedData = new FileReader();
             
              var privateKeyPEM;
              var encryptedData;
              
              readerPrivateKey.onload = function (event) {
                privateKeyPEM = event.target.result;
              };
              readerEncryptedData.onload = function (event) {
                encryptedData = event.target.result;
              };

              // Read the file as text (other options include 'readAsDataURL', 'readAsArrayBuffer', etc.)
              readerPrivateKey.readAsText(privateKeyFile);
              readerEncryptedData.readAsText(encryptedDatFile);
              fetch("../serverUpload/getSymKey.php", {
                      method: "GET",
                      headers: {
                          "Content-Type": "application/x-www-form-urlencoded",
                      },
                  }).then(response => response.text())
                  .then(data => {
                    let symKey = decrypSymKey(data,privateKeyPEM);
                    encryptedData = base64Decode(encryptedData);
                    const iv = encryptedData.slice(0, 16);
                    encryptedData = encryptedData.slice(16);

                    decryptData(btoa(encryptedData),btoa(symKey), btoa(iv))
                          .then(decryptedText => console.log('Decrypted Text:', decryptedText))
                          .catch(error => {
                            console.log(error.message);  // Log the error message
                            console.log(error.stack);    // Log the error stack trace
                    });
                  })
                  .catch(error => {
                      console.error("Error: " + error);
                  });
          } else {
              alert("Please select a file first.");
          }
        
      });
  }
  function urlSafeBase64Decode(input) {
    input = input.replace(/-/g, '+').replace(/_/g, '/');
    return atob(input);
}
function base64Decode(input) {
    try {
        return atob(input);
    } catch (error) {
        console.error('Error decoding base64:', error);
        return null;
    }
}
  async function decryptData(encryptedData, key, iv) {
    const encodedData = urlSafeBase64Decode(encryptedData);
    const dataBuffer = new Uint8Array(encodedData.length);
    for (let i = 0; i < encodedData.length; i++) {
        dataBuffer[i] = encodedData.charCodeAt(i);
    }

   // Convert base64-encoded key and IV to ArrayBuffer
   const keyBuffer = new Uint8Array(base64Decode(key).split('').map(char => char.charCodeAt(0)));
    if (!keyBuffer) {
        console.error('Invalid base64-encoded key');
        return null;
    }

    const ivBuffer = new Uint8Array(base64Decode(iv).split('').map(char => char.charCodeAt(0)));
    if (!ivBuffer) {
        console.error('Invalid base64-encoded IV');
        return null;
    }

    try {
        // Import the key
        const importedKey = await crypto.subtle.importKey(
            'raw',
            keyBuffer,
            { name: 'AES-GCM' },
            false,
            ['decrypt']
        );

        // Decrypt the data
        const decryptedData = await crypto.subtle.decrypt(
            {
                name: 'AES-GCM',
                iv: ivBuffer,
            },
            importedKey,
            dataBuffer
        );

        // Convert the decrypted ArrayBuffer to a string
        const decryptedString = new TextDecoder().decode(decryptedData);

        return decryptedString;
    } catch (error) {
        console.error('Error during decryption:', error);
        throw error; // Re-throw the error to provide more details in the catch block
    }

    // Convert the decrypted ArrayBuffer to a string
    const decryptedString = new TextDecoder().decode(decryptedData);

    return decryptedString;
}

  function decrypSymKey(data, privateKeyPEM){
    var base64EncryptedData = data; // Replace with the actual encrypted data

    // Decode the base64 encoded data
    var encryptedData = forge.util.decode64(base64EncryptedData);

    // Convert the private key from PEM format to Forge's Key object
    var privateKey = forge.pki.privateKeyFromPem(privateKeyPEM);

    // Decrypt the data using the private key
    var decryptedData = privateKey.decrypt(encryptedData);
    return decryptedData;
  }
</script>
    
</body>
</html>
