<?php
	require_once('../db/config.php');
	require_once('../user/auth.php');
	require_once('../encryptFunctions.php');
	session_start();

	if (isAuth() == 0) {
		header('Location: ../login.php');
		exit;
	}

	$userId = getUserId();
	$userEmail = $_SESSION['email'];
	$searchParams = "";
	$whereStm = "";

	if (isset($_GET['search'])) {
		$searchParams = $_GET['search'];
		$searchParams = mysqli_real_escape_string($link, $searchParams);

		$whereStm = "";

		if (isAdmin()) {
			$whereStm = " WHERE rooms.title LIKE '%$searchParams%' OR reservations.status LIKE '%$searchParams%'";
		} else {
			$whereStm = " AND (rooms.title LIKE '%$searchParams%' OR reservations.status LIKE '%$searchParams%')";
		}
	}

	if (isAdmin() == true) {
		// Get All reservations from the database
		$sql = "SELECT reservations.id as id, reservations.status as status, rooms.title as room_title, reservations.arrival_date as arrival_date, reservations.departure_date as departure_date, reservations.created_at as created_at, users.email as user_email
				FROM reservations INNER JOIN rooms ON reservations.room_id = rooms.id
				INNER JOIN users ON reservations.user_id = users.id
				$whereStm;";
	} else {
		// Get reservations from the database
		$sql = "SELECT reservations.id as id, reservations.status as status, rooms.title as room_title, reservations.arrival_date as arrival_date, reservations.departure_date as departure_date, reservations.created_at as created_at
				FROM reservations INNER JOIN rooms ON reservations.room_id = rooms.id
				WHERE reservations.user_id = $userId
				$whereStm;";
	}

	$result = mysqli_query($link, $sql);

	if (mysqli_num_rows($result) > 0) {
		$reservations = mysqli_fetch_all($result, MYSQLI_ASSOC);
	} else {
		$reservations = [];
	}

	function deleteReservation($id, $link) {
			$sql = "DELETE FROM reservations WHERE id = $id";
		$result = mysqli_query($link, $sql);
		if ($result) {
			echo "Reservation deleted successfully";
		}
		else {
			echo "Error deleting reservation: " . mysqli_error($link);
		}
	}
?>


<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Dashboard rezervácií</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
	<script src="https://unpkg.com/@popperjs/core@2"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
</head>
<style>
	td {
		vertical-align: middle;
	}
</style>
<body class="d-flex flex-column min-vh-100">
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>

	<div class='container'>
		<h3 class='mb-3 mt-1'>Rezervácie</h3>

		<div class='container'>
			<form action="reservations.php" method="GET" class='row justify-content-between'>
				<div class='col-6'>
					<a href="../reservation/create_reservation.php" class="btn btn-primary col-auto">
						Vytvoriť rezerváciu
					</a>
				</div>
				<div class='col-6 justify-content-end d-flex'>
					<input class="col-auto me-1" type="text" placeholder="Napíšte vyhľadávací parameter" name="search" aria-label="search-button">
					<button type="submit" id='search-btn' class='btn btn-primary col-auto'>
						Vyhľadať
					</button>
				</div>
			</form>
		</div>

		<table class="table">
			<thead>
				<tr>
					<th>Izba</th>
					<?php
						if (isAdmin() == true) {
							echo '<th>Email</th>';
						}
					?>
					<th>Dátum príchodu</th>
					<th>Dátum odchodu</th>
					<th>Dátum vytvorenia</th>
					<th>Stav</th>
					<th>
						<?php
							if (isAdmin() == false) {
								echo 'Akcie';
							}
						?>
					</th>
				</tr>
			</thead>
			<tbody>
				<?php foreach ($reservations as $reservation): ?>
					<tr>
						<td><?php echo $reservation['room_title']; ?></td>
						<?php
							if (isAdmin() == true) {
								echo '<td>' . $reservation['user_email'] . '</td>';
							}
						?>
						<td><?php echo $reservation['arrival_date']; ?></td>
						<td><?php echo $reservation['departure_date']; ?></td>
						<td><?php echo $reservation['created_at']; ?></td>
						<td>
							<?php
								if (isAdmin() == false) {
									switch($reservation['status']) {
										case 'PENDING':
											echo '<span class="badge bg-warning text-dark">Čaká na potvrdenie</span>';
											break;
										case 'CONFIRMED':
											echo '<span class="badge bg-success text-white">Potvrdená</span>';
											break;
										case 'CANCELLED':
											echo '<span class="badge bg-danger text-dark">Zrušená</span>';
											break;
										case 'DONE':
											echo '<span class="badge bg-secondary text-white">Dokončená</span>';
											break;
									}
								} else {
									// Create dropdown menu for admin to change reservation status

									// If reservation is cancelled, add button class btn-danger, if reservation is confirmed  btn-success, otherwise btn-secondary
									$btnClass = '';
									$status_text = '';
									switch($reservation['status']) {
										case 'CONFIRMED':
											$btnClass = 'btn-success';
											$status_text = 'Potvrdená';
											break;
										case 'CANCELLED':
											$btnClass = 'btn-danger';
											$status_text = 'Zrušená';
											break;
										default:
											$btnClass = 'btn-secondary';
											$status_text = 'Čaká na potvrdenie';
											break;
									}

									echo '<div class="dropdown">
											<button class="btn ' . $btnClass . ' dropdown-toggle" type="button" id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false">
												' . $status_text . '
											</button>
											<ul class="dropdown-menu" aria-labelledby="dropdownMenuButton1">
												<li><a class="dropdown-item" href="./change_reservation_status.php?id=' . $reservation['id'] . '&status=CONFIRMED">Potvrdená</a></li>
												<li><a class="dropdown-item" href="./change_reservation_status.php?id=' . $reservation['id'] . '&status=CANCELLED">Zrušená</a></li>
											</ul>
										</div>';
								}
							?>
						</td>
						<td>
							<?php
								if (isAdmin() == false) {
									$currentDate = date('Y-m-d');
									if ($reservation['status'] != 'CANCELLED' && $reservation['status'] != 'DONE' && $currentDate < $reservation['arrival_date'] && $currentDate < $reservation['departure_date']) {
										echo '<button id="delete-btn" type="button" class="btn btn-danger" data-bs-toggle="modal" data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Vymazať rezerváciu" data-bs-target="#delete-reservation-modal" data-id="' . $reservation['id'] . '">
												<i class="fas fa-trash"></i>
											</button>';
									}

									// If review for the reservation does not exist, show the button, otherwise show button to view review. User should write only one review per reservation
									$sql = "SELECT * FROM reviews WHERE reservation_id = " . $reservation['id'] . " AND user_id = " . $userId;
									$result = mysqli_query($link, $sql);
									$review = mysqli_fetch_assoc($result);

									if ($review) {
										echo '<a href="../review/view_review.php?review_id=' . $review['id'] . '" class="btn btn-primary" data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Zobraziť recenziu">
												<i class="fas fa-eye"></i>
											</a>';
									} else {
										if ($reservation['status'] == 'DONE') {
											echo '<a href="../review/write_review.php?reservation_id=' . $reservation['id'] . '" class="btn btn-primary" data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Napísať recenziu">
													<i class="fas fa-pen"></i>
												</a>';
										}
									}
								}
							?>
						</td>
					</tr>
				<?php endforeach; ?>
			</tbody>
		</table>
	</div>


	<div class="modal fade" id="delete-reservation-modal" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
			<div class="modal-header">
				<h1 class="modal-title fs-5" id="staticBackdropLabel">
					Naozaj chcete odstrániť rezerváciu?
				</h1>
				<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			</div>
			<div class="modal-body">
				Prajete si odstrániť rezerváciu?
				Stlačením tlačidla <b>Odstrániť</b> sa rezervácia navždy odstráni zo systému.
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Zrušiť</button>
				<button id="delete-btn-modal" type="button" class="btn btn-danger">Odstrániť</button>
			</div>
			</div>
		</div>
	</div>

	<script>
	$(document).ready(function() {
		$('#delete-btn').click(function() {
			var reservationId = $(this).data('id');
			$('#delete-reservation-modal').data('id', reservationId);
		});

		$('#delete-reservation-modal').click(function() {
			let id = $(this).data('id');

			$('#delete-btn-modal').click(function() {
				window.location.href = 'delete_reservation.php?id=' + id;
			});
		});
	});
	</script>
</body>

