<?php
include_once("./db/config.php");
session_start();

if ((isset($_SESSION["loggedin"]) && $_SESSION["loggedin"] === true)) {
	$userEmail = $_SESSION['email'];
	$role = $_SESSION["role"];
  }else{
    header("location: login.php");
    exit;
}



?>

<!DOCTYPE html>
<html lang="sk">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css"
        rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD"
        crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src='https://kit.fontawesome.com/3b6394f049.js' crossorigin='anonymous'></script>
    <link rel="stylesheet" type="text/css" href="../css/styles.css">
    <style>
        /* body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f4;
            color: #333;
            margin: 0;
        } */

        #fileInputWrapper {
            background-color: #fff;
            border: none;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0,0,0,0.05);
            margin-bottom: 20px;
            transition: box-shadow 0.3s ease;
        }

        #fileInputWrapper:hover {
            box-shadow: 0 6px 12px rgba(0,0,0,0.1);
        }

        /* p {
            font-size: 18px;
            margin-top: 0;
            color: #555;
        } */

        input[type="file"] {
            border: 2px solid #008cba;
            display: block;
            padding: 10px;
            margin-top: 10px;
            margin-bottom: 10px;
            border-radius: 4px;
            width: calc(100% - 22px); /* Adjust width considering padding and border */
            box-sizing: border-box; /* Include padding and border in element's width */
            cursor: pointer;
        }

        input[type="file"]::file-selector-button {
            background-color: #008cba;
            color: white;
            padding: 10px;
            border: none;
            border-radius: 4px;
            margin-right: 10px;
            cursor: pointer;
            transition: filter 0.3s ease;
        }

        input[type="file"]::file-selector-button:hover {
            filter: brightness(90%);
        }

        button, #generateKeys, #download-link {
            background-color: #00a0df;
            color: white;
            padding: 12px 25px;
            border: none;
            border-radius: 4px;
            cursor: pointer;
            font-size: 16px;
            transition: background-color 0.3s ease, transform 0.2s ease;
            display: block; /* Make buttons block-level for full width */
            width: 100%;
            box-sizing: border-box; /* Include padding and border in element's width */
        }

        button:hover, #generateKeys, #download-link {
            background-color: #0077b3;
            transform: translateY(-2px); /* Slight lift */
            box-shadow: 0 4px 8px rgba(0,0,0,0.1);
        }

        button:active, #generateKeys, #download-link {
            transform: translateY(1px); /* Pressed effect */
            box-shadow: none;
        }

        #fileContents {
            background-color: #f8f8f8;
            border: 1px solid #ddd;
            border-radius: 4px;
            padding: 15px;
            margin-top: 10px;
            white-space: pre-wrap;
            word-wrap: break-word;
            overflow-wrap: break-word;
            box-shadow: inset 0 1px 3px rgba(0,0,0,0.1);
            height: 150px; /* Set a fixed height */
            overflow-y: auto; /* Enable scroll if content is too long */
        }

        #savePubKey {
            padding: 0 20px;
        }

        #generateKeys, #download-link {
            text-align: center;
            text-decoration: none;
        }
    </style>
</head>

<!-- <body class="d-flex flex-column min-vh-100"> -->
<body>
	<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
        <div class="container">
            <a class="navbar-brand" href="#"><?php
						// Check if the user is logged in
						if (isset($userEmail)) {
							echo 'Welcome, ' . $userEmail;
						} 
						?></a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
                <ul class="navbar-nav">
                    <li class="nav-item">
                        <a class="nav-link" href="../index.php">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="../user/reservations.php">My reservations</a>
                    </li>
					<li class="nav-item">
						<?php
						// Check if the user is logged in
						if (!isset($userEmail)) {
							echo '<a class="nav-link" href="../login.php">Login</a>';
						}
						?>
					</li>
                    <li class="nav-item">
						<?php
						if (!isset($_SESSION['pubKey'])) {
							echo '<a class="nav-link" href="../userCreateKey.php">Add Keys</a>';
						}
						?>
					</li>
					<?php
						if (isset($_SESSION["role"]) && $_SESSION["role"]=="admin") {
							echo '<li class="nav-item">
							<a class="nav-link" href="../dashboard.php">Dashboard</a>
							</li>
							<li class="nav-item">
							<a class="nav-link" href="../createRoom.php">Create Room</a>
							</li>';
						}
						?>
					<li class="nav-item">
						<?php
						if (isset($userEmail)) {
							echo '<a class="nav-link" href="../logout.php">Log Out</a>';
						}
						?>
					</li>
                </ul>
            </div>
        </div>
    </nav>

    <!-- Rest of your index.php content -->



    

    <div id="savePubKey">
        <?php if( $_SESSION["pubKey"] === null) {
            echo '
            <p>Load your public key</p>
            <input type="file" id="fileInput">
            <button id="loadFileButton">Load File</button>
            <a id="generateKeys" class="mt-2">Generate keys</a>';
        }
        ?>
    </div>
    <div id="response"></div>


	<!-- <label>Encrypted file</label>
	<textarea id="encryptedFile" rows="10" cols="50"></textarea>

	<label>Private key</label>
	<textarea id="privateKey" rows="10" cols="50"></textarea>
	<button id="submitBtn">Submit</button> -->


	<script>
		// Load file contents into the textarea
		const privateKey = document.getElementById('privateKey');
		const encryptedFile = document.getElementById('encryptedFile');
		const submitBtn = document.getElementById('submitBtn');

		// submitBtn.addEventListener('click', function () {
		// 	const privateKey = document.getElementById('privateKey').value;
		// 	const encryptedFile = document.getElementById('encryptedFile').value;


		// 	// Regular expression pattern to extract the content between the delimiters
		// 	const pattern = /-----BEGIN PRIVATE KEY-----(.*?)-----END PRIVATE KEY-----/s;

		// 	// Use match to find the content between the delimiters
		// 	const matches = privateKey.match(pattern);

		// 	if (matches && matches[1]) {
		// 		// matches[1] will contain the content between the delimiters
		// 		const extractedKey = matches[1].trim(); // trim any whitespace
		// 		console.log(extractedKey);
		// 	} else {
		// 		console.error("No private key found in the file.");
		// 	}

		// 	// Assuming extractedKey is the base64-encoded key as a string
		// 	const base64PublicKey = privateKey;

		// 	// Decode the base64-encoded string to binary
		// 	// const binaryPrivateKey = atob(base64PublicKey);

		// 	// Function to chunk a string into specified lengths
		// 	function chunkSubstr(str, size) {
		// 		const numChunks = Math.ceil(str.length / size);
		// 		const chunks = new Array(numChunks);

		// 		for (let i = 0, o = 0; i < numChunks; ++i, o += size) {
		// 			chunks[i] = str.substr(o, size);
		// 		}

		// 		return chunks.join('\n');
		// 	}

		// 	// Create the PEM-formatted private key
		// 	// const pk = `-----BEGIN RSA PRIVATE KEY-----\n${chunkSubstr(btoa(base64PublicKey), 64)}\n-----END RSA PRIVATE KEY-----\n`;
		// 	const pk = `-----BEGIN RSA PRIVATE KEY-----\n MIIEvwIBADANBgkqhkiG9w0BAQEFAASCBKkwggSlAgEAAoIBAQC04LIb9LlvYU6c krGouxeF6BN1TuY8GDf0uVvAjRnNmoHLJzTVPjzNMu+B1gXRgNiHIcdy5ptOdVlS 3oDx50diFUzVnhrammzqSlC5lPKqMxIhDUD7Oiv87dZ+jBMlJGbvZaXkiV8SDCcN a85JpZg6L1/EpCyTc0aC0OOfd7pOIOKudkGSJcTZ54Zl2XKx3v/ndysfA2n0Yu1x EshDrHxGRd9gvz5VMLfZqWILKifCGNWD5f0wHOgYxW9rGXIj9hSkxhmVoLthpt8g pL45auvXAldfWg+CtL4WP9Ft00U39hsvjjHcDJYljvN4YabJcorQHD5hbCxV1tTa dzttT0AxAgMBAAECggEAB/6tiLRMtPpbV+rY/PEGFWZgY81AunPEl2XRAyYJd6/G YGUjffByDgzcDsRXvf6gs3pf/zlnsHRZ5iKNFwQmwNRZsNB79eEhAssVndpSTokS 2lCkaGZWFugpVK8a0oe1IAxBZKRYxiqw2DRFajZuT9YTuNSb3smX2oTipsQLQVQ6 Flf0K5KPghmdCpdCiAdObanPuibLf4qKWhv7lTXc5LNctMT1pCQZk8KKD1bmsElo xwMUXWY8N+EsYVUWmY3zl4BmdnQZV7LDs2g7fs2fmoRoq+8As1QQH7R4qpj5WR16 CtYpGK+hPpWr0s+RdpxNaM3rJpJDywoBj0mJu9Q/cQKBgQD2WJRA5wrsYSp1kEWA 9koYJfv49bElKvDd5fac+zYMvsBFyMZw+cU0UOfy6ei2w8OiRDuNMLD4IhRL1OO9 G+iFECLyFxAVsx4kEa2uzmCoRa30W0N05FGY981UPeKSSshXDGz/+FU/s5A4OTF1 L13RBx+2P+mttJdKI6uMGxsRqQKBgQC791FriI1OWXy9CW1m6hpxjpmsQS4+IQsz p0Wk5FazLLz/R4k8nLrVRXKkRqnrjYkjCfJME0DBfYoe4Vp0e6o27DIJnVBlAl7O Q8wNZ4nuAiOb9yXnMDoODS8BCVooNtUoChoFNRyOH+b3edWmyxVdW4yhiiGJihby awy6F63fSQKBgQDhZdLgP4XjGlR7FPJDORY6WibeeA8JbuzMW2j14XRm3PGX6EiJ fj9NyukvfY4MC7qocb37RZ3mq2feqn9lvG9XsJgI4ck50ZW2cuZzlykhTgAIIKjr /ywZxkH83lK8f+gmnZvt6Q43JtjCWLJEAn7YjqgZXQk2gpIap+CCZRqzYQKBgQC0 Udt7FKGysyh2VQ/t9dFudQW5eUI6egq7/9FREXiXJOke4OqoChc2OAx1yhCCl+Ii ig02rBWoSZ3yZ/AV5Pjy/X43OQKCFFcM+39KsLRibwzoN53V/q8DAeTA0s752zh7 080Ih94f/jzd1rR+8T5KtGPiKJhp0N6YqtenwsWbeQKBgQCQNJaG91+2NXGpH4yR 8yrgzfN9kFBzlvV+3FJaFnC6C7tSWn2MqxRAqUeG1rsYPvpUHJgfuV+e8jC9qmlP B9Poz1xDHgc1rU2LyOleU4olmvDXiowZoW7u2qt0WohvTWxigguQn3WUfrCBiJ40 UeqffIvsvhVovaWzzhyOannISQ== \n-----END RSA PRIVATE KEY-----\n`;

		// 	const symmetricKey = '!�ş��9Q�6�Ic$4f��掬���p�~�����Hp��+M����i=O$-ǂ�d���,��okh#Z��R]3�P*Y(�9�zAĬۘh��A�~.4w5���6�K���j�R��UVXB�q�ۈ��X�?b/P�e+�/�IFk�ɓQ|���}:��ݞ],�y2�I,H޶)�[��*o;M���R�i�1oə���`��v|��8�o)W���';

		// 	// const encryptedDataArrayBuffer = base64ToArrayBuffer(encryptedFile);
		// 	const encryptedDataArrayBuffer = encryptedFile;
		// 	// Assuming 'encryptedDataArrayBuffer' is an ArrayBuffer containing your encrypted data
		// 	const encryptedDataUint8Array = new Uint8Array(encryptedDataArrayBuffer);

		// 	// Extract the IV - the first 16 bytes of the encrypted data
		// 	const iv = encryptedDataUint8Array.slice(0, 16);

		// 	// Remove the IV from the encrypted data to get only the ciphertext
		// 	const ciphertext = encryptedDataUint8Array.slice(16);

		// 	// Example usage:
		// 	decryptData(ciphertext, iv, decryptedSymmetricKey)
		// 	.then(decryptedArrayBuffer => {
		// 		// Calculate the hash of the decrypted data for integrity check
		// 		calculateHash(decryptedArrayBuffer)
		// 		.then(decryptedDataHash => {
		// 			// Load the original hash and the encrypted data hash
		// 			const originalHash = 'dc648c5825bba39726dd29ecdbf531a6823940928ba5e82aa2926ed74ea9012b'; // Load this from 'original_hash.txt'
		// 			const encryptedDataHash = '16165e4ea57ec82fea82be4a8df00a4d33b6c905f0777c9c46dca7c888bd3f41'; // Load this from 'encrypted_data_hash.txt'

		// 			// Compare the original hash with the hash of the decrypted data
		// 			if (!compareHashes(originalHash, decryptedDataHash)) {
		// 			throw new Error('Integrity check failed');
		// 			} else {
		// 			console.log('Integrity check passed');
		// 			// Further processing with decrypted data can be done here
		// 			// For example, convert the ArrayBuffer to a string if the decrypted data is text
		// 			const decoder = new TextDecoder();
		// 			const decryptedText = decoder.decode(decryptedArrayBuffer);
		// 			console.log(decryptedText);
		// 			}
		// 		})
		// 		.catch(error => {
		// 			console.error('Hash calculation failed', error);
		// 		});
		// 	})
		// 	.catch(error => {
		// 		console.error('Decryption failed', error);
		// 	});

		// })

		// function base64ToArrayBuffer(base64) {
		// 	const binary_string = window.atob(base64);
		// 	const len = binary_string.length;
		// 	const bytes = new Uint8Array(len);
		// 	for (let i = 0; i < len; i++) {
		// 		bytes[i] = binary_string.charCodeAt(i);
		// 	}
		// 	return bytes.buffer;
		// }

		// async function decryptSymmetricKey(encryptedSymmetricKey, privateKey) {
		// 	try {
		// 		const decryptedSymmetricKey = await window.crypto.subtle.decrypt(
		// 		{
		// 			name: "RSA-OAEP"
		// 		},
		// 		privateKey,
		// 		encryptedSymmetricKey
		// 		);

		// 		// The decrypted symmetric key is returned as an ArrayBuffer.
		// 		return new Uint8Array(decryptedSymmetricKey);
		// 	} catch (e) {
		// 		console.error('Decryption of the symmetric key failed:', e);
		// 		throw e; // Rethrow the error or handle it as needed.
		// 	}
		// }

		// // Function to decrypt data
		// async function decryptData(ciphertext, iv, decryptedSymmetricKey) {
		// 	const cryptoKey = await window.crypto.subtle.importKey(
		// 		"raw",
		// 		decryptedSymmetricKey,
		// 		{ name: "AES-CBC", length: 256 },
		// 		false,
		// 		["decrypt"]
		// 	);

		// 	return window.crypto.subtle.decrypt(
		// 		{
		// 		name: "AES-CBC",
		// 		iv: iv
		// 		},
		// 		cryptoKey,
		// 		ciphertext
		// 	);
		// }

		// // Function to calculate SHA-256 hash
		// async function calculateHash(data) {
		// 	const hashBuffer = await window.crypto.subtle.digest('SHA-256', data);
		// 	const hashArray = Array.from(new Uint8Array(hashBuffer)); // convert buffer to byte array
		// 	const hashHex = hashArray.map(b => b.toString(16).padStart(2, '0')).join('');
		// 	return hashHex;
		// }

		// // Function to compare hashes
		// function compareHashes(originalHash, decryptedDataHash) {
		// 	return originalHash === decryptedDataHash;
		// }

	</script>
	<script src="./js/uploadFile.js"></script>
</body>
</html>

