import { Metadata } from 'next';
import './globals.css';
import { Inter } from 'next/font/google';
import { Provider } from '@/Components/TanstackProvider';
import { Toaster } from 'react-hot-toast';

const inter = Inter({ subsets: ['latin'] });

export const metadata: Metadata = {
  title: `TypeScript starter for Next.js`,
  description: `TypeScript starter for Next.js that includes all you need to build amazing apps`,
};

export default function RootLayout({
  children,
}: {
  children: React.ReactNode;
}) {
  return (
    <html lang="en">
      <body className={inter.className}>
        <Toaster position="bottom-center" />
        <Provider>{children}</Provider>
      </body>
    </html>
  );
}
