import { z } from 'zod';

export const NewUserResponseSchema = z.object({
  name: z.string(),
  surname: z.string(),
  email: z.string(), // Since the data in this schema are encrypted the email can't be checked if it has correct format
  password: z.string(),
});

export type NewUserResponse = z.infer<typeof NewUserResponseSchema>;
