import { z } from 'zod';

export const UserSchema = z.object({
  id: z.number(),
  name: z.string(),
  surname: z.string(),
  email: z.string(), // Since the data in this schema are encrypted the email can't be checked if it has correct format
  address: z.string().nullish(),
  voted: z.number(),
  password: z.string(),
  publicKey: z.string(),
  loginAttempts: z.number(),
  lastLoginAttempt: z.number(),
});

export type User = z.infer<typeof UserSchema>;
