<?php

namespace App\Http\Controllers;
use App\Models\Item;

use Illuminate\Http\Request;

class PayGateController extends Controller
{
    public function index()
    {
        return view('shop.payGate');
    }

    public function pay(Request $request){
        $cart = request()->cookie('cart');
        $itemData = array();
        $total = 0;
        if ($cart && is_string($cart) && @unserialize($cart) !== false) {
            $cart = unserialize($cart);

            // Get the items from the database
            $items = Item::whereIn('id', array_column($cart, 'product_id'))->get();
            $total = 0;
            // Attach the quantity information to each item

            foreach ($items as $item) {
                $key = array_search($item->id, array_column($cart, 'product_id'));
                $item->qty = $cart[$key]['quantity'];
                $total = $total + $item->price * $item->qty;
                $ItemInStore = Item::find($item->id);
                $ItemInStore->quantity = $ItemInStore->quantity - $item->qty;
                $ItemInStore->save();
                array_push($itemData, ['name' => $ItemInStore->name, 'quantity' => $item->qty, 'price' => $item->price, 'totalPerItem' => $item->price * $item->qty]);
            }

            $output = [
                "itemData" => $itemData,
                "total" => $total,
                'user' => auth()->user()->email,
                'dateAndTime' => "Generated on: " . date("Y-m-d H:i:s"),
                'contractNumber' => "Contract number: " . rand(100000, 999999),
            ];
            // save Order to DB
            $user = auth()->user();
            $order = new \App\Models\Order();
            $order->user_id = $user->id;
            $order->data= json_encode($output);
            $order->contract_number = $output['contractNumber'];
            $order->save();

            cookie()->queue(cookie()->forget('cart'));
            cookie()->queue(cookie()->make('name', null, -1));

            session(['itemData' => $itemData, 'total' => $total, 'orderId' => $order->id]);
            return redirect()->route('auth.contract.show');
        }
        else {
            return redirect()->back()->withErrors(['error' => 'Cart is empty, nothing to pay for']);
        }

    }
}
