<?php

namespace App\Http\Controllers;

use App\Models\Item;
use App\Models\Order;
use App\Models\User;
use Illuminate\Http\Request;

class ProfileController extends Controller
{
    public function index()
    {
        $user = auth()->user();

        if ($user) {
            $orders = Order::where('user_id', $user->id)->get();
            return view('auth.profile', compact('user', 'orders'));
        } else {
            // Handle the case where the user is not authenticated
            return redirect()->route('login');
        }
    }


    public function savePublicKey(Request $request)
    {
        $id = $request->input('id');
        $user = auth()->user();
        $user->update([
            'public_key' => $request->input('hiddenField'),
        ]);
        // Get the user detail from the database
        $user = User::find($id);

        return redirect()->back();
    }
}
