<?php

namespace App\Http\Controllers;

use App\Models\Review;
use Illuminate\Http\Request;

class ReviewController extends Controller
{
    public function store(Request $request)
    {
        if (!auth()->check()) {
            return redirect()->back()->with('error', 'Please log in to submit the form.');
        }

        $validatedData = $request->validate([
            'review_text' => 'required',
            'rating' => 'required|numeric|min:1|max:5',
            'product_id' => 'required|exists:items,id'
        ]);

        Review::create([
            'user_id' => auth()->id(),
            'product_id' => $validatedData['product_id'],
            'review_text' => $validatedData['review_text'],
            'rating' => $validatedData['rating']
        ]);

        return redirect()->back()->with('success', 'Review submitted successfully');
    }

}
