<?php

namespace App\Providers;

use App\Models\Item;
use Cookie;
use Illuminate\Support\Facades\View;
use Illuminate\Support\ServiceProvider;

class CartServiceProvider extends ServiceProvider
{
    /**
     * Register services.
     */
    public function register(): void
    {
        //
    }

    /**
     * Bootstrap services.
     */
    public function boot(): void
    {
        View::composer('*', function ($view) {
            $cart = request()->cookie('cart');

            // Check if the cart cookie is set and is a serialized string
            if ($cart && is_string($cart) && @unserialize($cart) !== false) {
                $cart = unserialize($cart);

                // Get the items from the database
                $items = Item::whereIn('id', array_column($cart, 'product_id'))->get();

                // Attach the quantity information to each item
                foreach ($items as $item) {
                    $key = array_search($item->id, array_column($cart, 'product_id'));
                    $item->qty = $cart[$key]['quantity'];
                }
            } else {
                $items = [];
            }

            //$view->with('numberOfItems', $items->count());
        });
    }
}
