<?php

namespace Database\Factories;

use App\Models\Item;
use Illuminate\Database\Eloquent\Factories\Factory;

/**
 * @extends \Illuminate\Database\Eloquent\Factories\Factory<\App\Models\Item>
 */
class ItemFactory extends Factory
{
    protected $model = Item::class;
    /**
     * Define the model's default state.
     *
     * @return array<string, mixed>
     */
    public function definition(): array
    {
        $category = $this->faker->randomElement(['bicycle', 'scooter']);
        $imageNumber = ($category === 'bicycle') ? $this->faker->numberBetween(1, 6) : $this->faker->numberBetween(1, 4);
        $imageName = $category . $imageNumber . '.png';

        return [
            'name' => $this->faker->name(),
            'description' => $this->faker->text(700),
            'price' => $this->faker->randomFloat(2, 10, 100),
            'quantity' => $this->faker->numberBetween(1, 10),
            'category' => $category,
            'image' => '/' . $imageName,
        ];
    }
}
