////////////////////////////////////////////////////////////////////////////
//              Generate KeyPair
////////////////////////////////////////////////////////////////////////////
$("#generate-key-form").submit(function (event) {
    event.preventDefault();
    var encrypt = new JSEncrypt();
    var keyPair = encrypt.getKey(); // Generate RSA key pair

    $("#hidden-public-key").val(keyPair.getPublicKey());
    console.log("Public Key: " + keyPair.getPublicKey());
    downloadKeyPair(keyPair);
    this.submit();
    alert("Public key successfuly uploaded in our database!");
});

////////////////////////////////////////////////////////////////////////////
//              Download KeyPair
////////////////////////////////////////////////////////////////////////////
var downloadKeyPair = function (keyPair) {
    var privateKey = keyPair.getPrivateKey();
    var publicKey = keyPair.getPublicKey();
    var privateFilename = "private_key.pem";
    var publicFilename = "public_key.pem";
    var privateBlob = new Blob([privateKey], {
        type: "application/octet-stream",
    });
    var publicBlob = new Blob([publicKey], {
        type: "application/octet-stream",
    });
    var privateLink = document.createElement("a");
    var publicLink = document.createElement("a");
    privateLink.href = window.URL.createObjectURL(privateBlob);
    publicLink.href = window.URL.createObjectURL(publicBlob);
    privateLink.download = privateFilename;
    publicLink.download = publicFilename;
    privateLink.click();
    publicLink.click();
};

////////////////////////////////////////////////////////////////////////////
//              Upload Private Key to browser session storage
////////////////////////////////////////////////////////////////////////////
$("#uploadPrivateKeyFile").click(function () {
    var fileInput = document.getElementById("fileInput");
    var file = fileInput.files[0];
    var reader = new FileReader();
    reader.onload = function (event) {
        var private_key = event.target.result;
        sessionStorage.setItem("privateKey", private_key);
        if (sessionStorage.getItem("privateKey")) {
            alert("Private key successfully uploaded to session storage!");
        } else {
            alert("Private key upload failed!");
        }
    };
    // Don't forget to start reading the file
    reader.readAsText(file);
});

////////////////////////////////////////////////////////////////////////////
//      Receive the encrypted file and decrypt symmetric key
////////////////////////////////////////////////////////////////////////////
$(".generate-file").click(function () {
    console.log("PIPIK");
    if (!sessionStorage.getItem("privateKey")) {
        alert("Upload private key first, to decrypt the incoming data.");
        return;
    }

    $.ajax({
        url: "/profile/generate/file/"+$(this).data('id'),
        dataType: "json",
        success: function (data) {
            console.log(data);
            decryptionProcess(
                data["header"]["encrypted_symmetric_key"],
                data["header"]["iv"],
                data["data_file"],
                data["header"]["signature_for_encd_symm_key"],
                data["header"]["server_public_key"]
            );
             //window.location.href = "/profile";
        },
        error: function (xhr, status, error) {
            console.error("An error occurred:", error);
        },
    });
});

////////////////////////////////////////////////////////////////////////////
//                          Decryption process
////////////////////////////////////////////////////////////////////////////
var decryptionProcess = function (
    encryptedSymmetricKey,
    iv,
    encryptedData,
    signature,
    serverPubKey
) {
    // Verify signature (DOESNT WORK ON CLIENT SIDE)

    // if (!verifySignature(serverPubKey, signature, decryptedData)) {
    //     console.log("Signature verification failed!");
    //     return;
    // }
    // console.log("Signature verification successful!");

    //Decrypt symmetric key
    let decryptedSymmKey = decryptSymmetricKey(encryptedSymmetricKey);

    //Decrypt data and print
    let decryptedData = decryptData(encryptedData, decryptedSymmKey, iv);
    console.log("Decrypted Data:", decryptedData);

    generatePDF(decryptedData);
};

////////////////////////////////////////////////////////////////////////////
//                          DECRYTP SYMMETRIC KEY
////////////////////////////////////////////////////////////////////////////
function decryptSymmetricKey(encryptedSymmetricKey) {
    const privateKey = forge.pki.privateKeyFromPem(
        sessionStorage.getItem("privateKey")
    );
    var decryptedSymmKey = privateKey.decrypt(
        hexToBin(encryptedSymmetricKey),
        "RSA-OAEP"
    );
    return decryptedSymmKey;
}

////////////////////////////////////////////////////////////////////////////
//                          DECRYPT FILE DATA
////////////////////////////////////////////////////////////////////////////
function decryptData(encryptedData, decryptedSymKey, iv) {
    console.log("Encrypted data HEX:", encryptedData);
    console.log("Encrypted data:", hexToBin(encryptedData));
    var decipher = forge.cipher.createDecipher("AES-CBC", decryptedSymKey);
    decipher.start({
        iv: hexToBin(iv),
    });
    decipher.update(forge.util.createBuffer(hexToBin(encryptedData), "raw"));
    const decryptedData = decipher.output;

    decryptedData.data = removeNonBase64Chars(decryptedData.data);
    return decryptedData.data;
}
////////////////////////////////////////////////////////////////////////////
//                          VEIRFY SIGNATURE
////////////////////////////////////////////////////////////////////////////
import KJUR from "jsrsasign";
import forge from "node-forge";

function verifySignature(publicKey, signature, data) {
    const sig = new KJUR.crypto.Signature({ alg: "SHA256withRSA" });
    console.log("Public Key:", hexToBin(publicKey));
    console.log("Signature:", hexToBin(signature));
    console.log("Data:", data);

    sig.init(hexToBin(publicKey));
    sig.updateString(data);
    return sig.verify(hexToBin(signature));
}

function verifySignature2(publicKey, signature, data) {
    const verifier = forge.pki.publicKeyFromPem(hexToBin(publicKey));
    return verifier.verify(hexToBin(data), hexToBin(signature));
}

////////////////////////////////////////////////////////////////////////////
//                          OTHER FUNCTIONS
////////////////////////////////////////////////////////////////////////////
function hexToBin(hexString) {
    var binaryString = "";
    for (var i = 0; i < hexString.length; i += 2) {
        var hex = hexString.substr(i, 2);
        var codePoint = parseInt(hex, 16);
        var char = String.fromCharCode(codePoint);
        try {
            encodeURIComponent(char);
        } catch (e) {
            return binaryString;
        }
        binaryString += char;
    }
    return binaryString;
}

function removeNonBase64Chars(str) {
    return str.replace(/[^ -~]/g, "");
}
import jsPDF from "jspdf";
function generatePDF(jsonData) {
    jsonData = JSON.parse(jsonData);

    // Create a new jsPDF instance
    var pdf = new jsPDF();
    // Set font size and style for the title
    pdf.setFontSize(16);
    pdf.setFont('helvetica', 'bold');

    // Calculate the position for the title to be in the middle
    var titleWidth = pdf.getStringUnitWidth('Invoice Details') * pdf.internal.getFontSize();
    var titleX = (pdf.internal.pageSize.width - titleWidth) / 2;

    // Add title to the PDF
    pdf.text('Invoice Details', titleX, 10);

    // Set font size and style for the content
    pdf.setFontSize(12);
    pdf.setFont('helvetica', 'normal');

    // Add content to the PDF
    pdf.text("User: " + jsonData.user, 20, 20);
    pdf.text("Date and Time: " + jsonData.dateAndTime, 20, 30);
    pdf.text("Contract Number: " + jsonData.contractNumber, 20, 40);

    pdf.text("Item Data:", 20, 60);
     var yPosition = 70;
    jsonData.itemData.forEach(function (item, index) {
        pdf.text(
            "- " +
                item.name +
                " - Quantity: " +
                item.quantity +
                " - Price: $" +
                item.price +
                " - Total: $" +
                item.totalPerItem,
            30,
            yPosition
        );
        yPosition += 20;
    });

    pdf.text("Total: $" + jsonData.total, 20, yPosition);

    // Save the PDF
    pdf.save("invoice.pdf");
}
