@extends('layouts.layout-default')


@section('content')
@vite(['resources/js/crypto.js'])
    <div class="container mx-auto mt-8 p-8 bg-white rounded-lg shadow-md">

        <!-- Invoice Header -->
        <div class="mb-8 text-green-600">
            <h2 class="text-3xl font-bold">Your purchase has been completed!</h2>
        </div>
        <div class="mb-8 text-center">
            <h2 class="text-3xl font-bold">Invoice</h2>
        </div>

        <!-- Product Details -->
        <div class="mb-8">
            <table class="w-full">
                <thead>
                    <tr>
                        <th class="py-2">Product Name</th>
                        <th class="py-2">Quantity</th>
                        <th class="py-2">Price per Item</th>
                        <th class="py-2">Total Price</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($itemData as $item)
                        <tr>
                            <td class="border px-4 py-2">{{ $item['name'] }}</td>
                            <td class="border px-4 py-2">{{ $item['quantity'] }}</td>
                            <td class="border px-4 py-2">{{ $item['price'] }}</td>
                            <td class="border px-4 py-2">{{ $item['totalPerItem'] }}</td>
                        </tr>
                    @endforeach
                    <!-- End of dynamic data -->

                    <!-- Total Row -->
                    <tr>
                        <td class="border px-4 py-2" colspan="3" class="text-right font-bold">Total:</td>
                        <td class="border px-4 py-2 font-bold">{{$total}}</td>
                    </tr>
                </tbody>
            </table>
        </div>

         {{-- GET ENCRYPTED FILE --}}
            <div class="text-center mt-14">
                <button data-id="{{$orderId}}" class="btn btn-primary generate-file">Download
                Contract</button>
            </div>

    </div>
@endsection
