{{-- create user profile page where he can add a public key via input --}}
@extends('layouts.layout-default')

@section('content')
@vite(['resources/js/cart.js'])
    @auth
        <div class="flex flex-col  mt-4 justify-center">

            {{-- GENERATE KEY PAIR --}}
            <div class="mb-5">
                <form id="generate-key-form" action="{{ route('user.upload.public.key') }}" method="post">
                    @csrf
                    @method('POST')
                    <input id="hidden-public-key" type="hidden" name="hiddenField" value="">
                    <button  class="bg-blue-500 hover:bg-blue-700 text-white py-2 px-4 rounded" id="generate-key-pair">Generate Key Pair</button>
                </form>
            </div>

            {{-- UPLOAD PRIVATE KEY --}}
            <div class="mb-5 d-flex">
                <div class="d-flex">
                    <div class="custom-file">
                        <input type="file" class="custom-file-input" id="fileInput" accept=".txt, .pem">
                        <label class="custom-file-label" for="fileInput">Upload private key</label>
                    </div>
                    <button id="uploadPrivateKeyFile" class="bg-blue-500 hover:bg-blue-700 text-white py-2 px-4 rounded ml-2" >Submit</button>
                </div>
            </div>

            {{-- SEARCH BAR --}}
            <div class="mb-5">
                <form action="{{ route('auth.search.contracts') }}" method="GET">
                    <label for="search" class="block text-gray-700 font-bold mb-2">Search contracts:</label>
                    <input type="text" id="search" name="search" class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline" list="contracts" placeholder="Search contracts...">
                    <datalist id="contracts">
                        @foreach($orders as $order)
                            <option value="{{ $order->contract_number }}">
                        @endforeach
                    </datalist>
                    <button type="submit" class="bg-blue-500 hover:bg-blue-700 text-white py-2 px-4 rounded mt-2" >Search</button>
                </form>
            </div>

            {{-- LIST CONTRACTS --}}
            <div class="flex flex-col mt-4 justify-center">
                <h2 class="text-lg font-medium mb-4">Invoice Contracts</h2>
                @if(count($orders) > 0)
                    <div class="overflow-x-auto">
                        <table class="table-auto border-collapse w-full">
                            <thead>
                                <tr>
                                    <th class="px-4 py-2 text-left">Contract Number</th>
                                    <th class="px-4 py-2 text-left">Date Created</th>
                                    <th class="px-4 py-2 text-left">Download</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($orders as $order)
                                <tr>
                                    <td class="border px-4 py-2">{{ $order->contract_number }}</td>
                                    <td class="border px-4 py-2">{{ $order->created_at->format('d/m/Y') }}</td>
                                    <td class="border px-4 py-2">
                                        <button data-id="{{$order->id}}" class="generate-file text-blue-600 hover:underline">Download</button>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                @else
                    <p>No contracts found.</p>
                @endif
            </div>


        </div>
        @vite(['resources/js/crypto.js'])
    @endauth
@endsection

