@extends('layouts.layout-default')
@section('content')
    @vite(['resources/js/cart.js'])
    <div class="container mx-auto">
        <div class="py-8">
            <h1 class="text-3xl font-bold">Your Cart</h1>
            <table class="w-full mt-8 table-auto">
                <thead>
                    <tr class="bg-gray-200 text-gray-700 uppercase text-sm leading-normal">
                        <th class="py-3 px-6 text-left">Product</th>
                        <th class="py-3 px-6 text-left">Quantity</th>
                        <th class="py-3 px-6 text-left">Price</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($cartItems as $cartItem)
                        <tr class="border-b border-gray-200 hover:bg-gray-100">
                            <td class="py-3 px-6 text-left">{{ $cartItem->name }}</td>
                            <td class="py-3 px-6 text-left">
                                <button id="decrease-item-quantity" data-id="{{ $cartItem->id }}"
                                    class="manage-cart bg-red-500 hover:bg-red-700 text-white font-bold py-1 px-3 rounded-full">
                                    -
                                </button>
                                <span class="font-semibold px-1">{{ $cartItem->qty }}</span>
                                <button id="increase-item-quantity" data-id="{{ $cartItem->id }}"
                                    class="manage-cart bg-blue-500 hover:bg-blue-700 text-white font-bold py-1 px-3 rounded-full">
                                    +
                                </button>
                                <span id=""></span>
                            </td>
                            <td class="py-3 px-6 text-left">{{ $cartItem->price * $cartItem->qty }}€
                                @if ($cartItem->qty > 1)
                                    ({{ $cartItem->price }}€/product)
                                @endif
                            </td>

                        </tr>
                    @endforeach
                    <tr class="border-b border-gray-200">
                        <td></td>
                        <td colspan="1" class="py-3 px-6 text-right"> </td>
                        @php
                            if (!empty($cartItems)) {
                                $total = $cartItems->reduce(function ($carry, $item) {
                                    return $carry + $item->price * $item->qty;
                                }, 0);
                            } else {
                                $total = 0;
                            }
                        @endphp

                        {{-- Rest of your HTML... --}}


                        <td class="py-3 px-6 text-right">Total Price: {{ $total }} €</td>
                    </tr>

                </tbody>
            </table>
            <script>
                window.onload = function() {
                    var privateKey = sessionStorage.getItem('privateKey');
                    if (privateKey == null || privateKey == undefined || privateKey == "" ) {
                        alert('You need to assign a private key to your session first! You will be redirected to your profile.');
                        window.location.href = '/profile';
                    }
                }
            </script>
            @if ($hasPublicKey)
            <a href="/payGate" id="checky" class="inline-block mt-8 px-4 py-2 bg-blue-500 text-white rounded-lg">Checkout</a>
            @else
            <div class="flex flex-col mt-4">
                <span class="text-center text-4xl">V profile užívateľa si musíte najskôr vytvoriť kľúčový pár a nahrať súkromný kľúč!</span>
                <a href="/profile" class="text-center mt-2 px-4 py-2 bg-gray-500 text-white rounded-lg disabled">Profil</a>
            </div>
            @endif
        </div>
    </div>
@endsection
