@extends('layouts.layout-default')
@section('content')
@vite(['resources/js/cart.js'])
    <script>
        let itemId = {{ $item->id }}
    </script>
    <div class="container mx-auto p-4">
        <div class="bg-white shadow-lg rounded-lg overflow-hidden p-4">
            <form class="md:flex" action="">
                <div class="md:flex-shrink-0 justify-around">
                    <img class="w-full object-cover" src={{ $item->image }} alt="Category image"
                    loading="lazy">
                </div>
                <div class=" flex flex-col justify-evenly p-8">
                    <div id="item-name"class="uppercase tracking-wide text-5xl text-indigo-500 font-semibold">
                        {{ $item->name }}</div>
                    <p id="item-description" class="text-gray-500 text-xs">{{ $item->description }}</p>
                    <p class="hidden"></p>
                    <div class="mt-4">
                        <span id="item-price" class="text-gray-600 font-bold text-xl">Price: {{ $item->price }}€</span>
                    </div>
                    <div class="mt-2">
                        <span id="item-quantity" class="text-gray-400">Products in stock: {{ $item->quantity }}</span>
                    </div>
                    <div class="mt-4">
                        <button id="increase-item-quantity" data-id="{{  $item->id}}" href="/addToCart/{id}" id="add-to-cart-btn"
                            class="manage-cart text-2xl bg-blue-500 hover:bg-blue-700 text-white font-bold py-3 px-12 rounded-full">
                            Add to Cart
                        </button>
                    </div>
                </div>
            </form>
        </div>
        <div class="bg-white shadow-lg rounded-lg overflow-hidden p-4 m-4">
            <h3 class="uppercase tracking-wide text-3xl text-indigo-500 font-semibold my-3">Comments</h3>
            <div class="bg-red">
                    @foreach ($reviews as $review)
                        <div class="w-full border px-4 py-3 text-gray-800 bg-gray-100 my-2">
                            <p class="text-right"> {{ $review->created_at }} </p>
                            <p>
                                <span class="font-medium">Review by:</span>
                                {{ $review->user->first_name }} {{ $review->user->last_name }}
                            </p>
                            <p>
                                <span class="font-medium">Rating:</span>
                                {{ $review->rating }} out of 5
                            </p>
                            <p>{{ $review->review_text }}</p>
                        </div>
                    @endforeach
            </div>
            <form action="{{ route('reviews.store') }}" method="POST" class="bg-gray-900 p-4 text-white my-3">
                @csrf
                <div>
                    <input type="hidden" name="product_id" value="{{ $item->id }}">
                    <label for="rating" class="underline ">Rating:</label>
                    <div class="rating-options space-x-2">
                        <div class="inline">
                            <input type="radio" name="rating" id="rating1" value="1">
                            <label for="rating1">1 (low)</label>
                        </div>
                        <div class="inline">
                            <input type="radio" name="rating" id="rating2" value="2">
                            <label for="rating2">2</label>
                        </div>
                        <div class="inline">
                            <input type="radio" name="rating" id="rating3" value="3">
                            <label for="rating3">3</label>
                        </div>
                        <div class="inline">
                            <input type="radio" name="rating" id="rating4" value="4">
                            <label for="rating4">4</label>
                        </div>
                        <div class="inline">
                            <input type="radio" name="rating" id="rating5" value="5">
                            <label for="rating5">5 (high)</label>
                        </div>
                    </div>
                </div>
                <div class="my-2">
                    <label for="review_text" class="underline ">Your Review:</label>
                    <textarea name="review_text" id="review_text" rows="4"
                              class="w-full p-2 resize-none border focus:border-blue-500 text-gray-800 bg-gray-100">
                    </textarea>
                </div>
                @auth
                    <button type="submit"
                            class="text-sm bg-indigo-500 hover:bg-indigo-700 text-white font-bold py-2 px-4 rounded-full">
                        Submit Review
                    </button>
                @else
                    <a href="{{route("auth.login.index") }}"
                            class="text-sm bg-slate-300 hover:bg-slate-500 text-black font-bold py-2 px-4 rounded-full">
                        Log in
                    </a>
                @endauth
            </form>
        </div>
    </div>
@endsection
