{{-- create user profile page where he can add a public key via input --}}
@extends('layouts.layout-default')

@section('content')
    <div class="flex-grow flex flex-col pb-10 my-5  items-start bg-gray-100">
        <div class="container mx-auto px-2 sm:px-6 lg:px-8">
            <form method="GET" action="{{ route('listings.index') }}" class="mb-5">
                <input type="text" name="search" list="items"
                    class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
                    placeholder="Search items..." value="{{ request()->query('search') }}">
                <datalist id="items">
                    @foreach ($items as $item)
                        <option value="{{ $item->name }}">
                    @endforeach
                </datalist>
            </form>
            <article id="article-page" class="sm:px-5 grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 lg:grid-cols-4 gap-7">
                @foreach ($items as $item)
                    <div
                        class="bg-white rounded overflow-hidden shadow-md hover:shadow-2xl transition-shadow duration-300 ease-in-out">
                        <a href="{{ route('listings.show', $item->id) }}" class="text-blue-500 hover:text-blue-700">
                            <div class="px-4 py-2 bg-gray-200">
                                <h3 id="heading-h5"
                                    class="text-lg font-medium text-gray-800 overflow-hidden line-clamp-2 h-14">
                                    {{ $item->name }}
                                </h3>
                            </div>
                            <img class="h-48 w-full object-cover" src={{ $item->image }} alt="Category image"
                                loading="lazy">
                        </a>
                        <div class="flex justify-between">
                            <span id="date-span" class=" text-sm w-full p-2 block bg-gray-100">Price: {{ $item->price }}€</span>
                            <span id="date-span" class="text-right text-sm w-full p-2 block bg-gray-100">In stock:
                                {{ $item->quantity }}</span>
                        </div>
                    </div>
                @endforeach
            </article>
            <div class="mt-4">
                {{ $items->links() }}
            </div>
        </div>
    </div>

@endsection
