@extends('layouts.layout-default')

@section('content')
    <div class="my-4">
        @if ($errors->any())
            <div class="flex justify-center items-center  alert alert-danger">
                <ul class="">
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
        <form class="flex justify-center items-center" method="POST" action="{{ route('paygate.pay') }}">
            @csrf
            @method('POST')
            <div class="w-1/2 mt-8 border-2 border-black rounded-lg p-4">
                <h2 class="text-2xl font-bold mb-4">
                    PayGate
                </h2>
                <div>
                    <div class="flex flex-row">
                        <div class="flex flex-col">
                            <p class="bg-gray-300 pt-2 px-2 rounded-lg">Číslo vašej karty</p>
                            <p class="bg-gray-300 pt-2 mt-2 px-2 rounded-lg">Platnosť vašej karty</p>
                            <p class="bg-gray-300 pt-2 mt-2 px-2 rounded-lg">CV</p>
                        </div>

                        <div class="flex flex-col ml-2">
                            <input type="text" class="border p-1 rounded-lg" required>
                            <div class="flex flex-row mt-2">
                                <select name="month" id="month" class="p-1 rounded-lg mr-2" required>
                                    <option value="1">Január</option>
                                    <option value="2">Február</option>
                                    <option value="3">Marec</option>
                                    <option value="4">Apríl</option>
                                    <option value="5">Máj</option>
                                    <option value="6">Jún</option>
                                    <option value="7">Júl</option>
                                    <option value="8">August</option>
                                    <option value="9">September</option>
                                    <option value="10">Október</option>
                                    <option value="11">November</option>
                                    <option value="12">December</option>
                                </select>
                                <select name="year" id="year" class="p-1 rounded-lg mr-2" required>
                                    @for ($year = 2023; $year <= 2028; $year++)
                                        <option value="{{ $year }}">{{ $year }}</option>
                                    @endfor
                                </select>
                            </div>
                            <input type="text" class="w-10 border p-1 rounded-lg" size="3" maxlength="3"
                                placeholder="***" required>
                        </div>
                    </div>
                </div>
                <div class="flex justify-center mt-4">
                    <button type="submit"
                        class="text-white bg-gray-900 py-1 px-2 border-2 rounded-lg hover:bg-gray-800">Zaplatiť</button>
                </div>
            </div>
        </form>
    </div>
@endsection
