<?php

use App\Http\Controllers\CryptographyController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\Auth\RegisterController;
use App\Http\Controllers\ListingsController;
use App\Http\Controllers\LogoutController;
use App\Http\Controllers\OpenSSLController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ReviewController;
use App\Http\Controllers\PayGateController;
use App\Http\Controllers\ContractController;
use Illuminate\Support\Facades\Route;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/



Route::get('/', [LoginController::class, 'index'])->name('auth.login.index');



Route::get('/login', [LoginController::class, 'index'])->name('auth.login.index');
Route::post('/login', [LoginController::class, 'login'])->name('auth.login');

Route::get('/register', [RegisterController::class, 'index'])->name('auth.register.index');
Route::post('/register', [RegisterController::class, 'register'])->name('auth.register');

Route::get('/logout', [LogoutController::class, 'logout'])->name('auth.logout');

Route::middleware('auth')->group(function () {
    Route::get('/', function () {
        return view('index');
    })->name('index');

    Route::get('/message', function () {
        return view('crypt.message');
    })->name('message');

    Route::get('/profile', [ProfileController::class, 'index'])->name('user.profile.index');
    Route::post('/profile/generate', [ProfileController::class, 'savePublicKey'])->name('user.upload.public.key');
    Route::get('/profile/generate/file/{id}', [OpenSSLController::class, 'encryptData'])->name('generate.encrypted.file');
    Route::get('/auth/contract', [ContractController::class, 'show'])->name('auth.contract.show');
    Route::get('/auth/contract/search', [ContractController::class, 'searchedContracts'])->name('auth.search.contracts');
});

###################################################################################################
#                           LISTINGS OF ITEMS
###################################################################################################
Route::get('/listings/index', [ListingsController::class, 'index'])->name('listings.index');
Route::get('/listings/cart', [ListingsController::class, 'showCart'])->name('listings.cart');

Route::get('/listings/{item}', [ListingsController::class, 'show'])->name('listings.show');
Route::get('/listings/update-cart', [ListingsController::class, 'updateCart'])->name('update.cart');

Route::post('/listings/add-to-cart', [ListingsController::class, 'updateCart'])->name('add.to.cart');


Route::post('/reviews', [ReviewController::class, 'store'])->name('reviews.store');

Route::get('/payGate', [PayGateController::class, 'index'])->name('paygate.index');
Route::post('/pay', [PayGateController::class, 'pay'])->name('paygate.pay');
