package com.example.upbz5.models;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "USERS", uniqueConstraints = {@UniqueConstraint(columnNames = "Email")})
public class User {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "Id")
    private Long id;

    @NotNull
    @Size(max = 50)
    @Column(name = "Name", length = 50)
    private String name;

    @NotNull
    @Size(max = 100)
    @Column(name = "Surname", length = 100)
    private String surname;

    @NotNull
    @Size(max = 100)
    @Column(name = "Email", length = 100)
    private String email;

    @NotNull
    @Size(max = 100)
    @Column(name = "Password")
    private String password;

    @NotNull
    @Column(name = "Public_key", length = 2048)
    private String publicKey;

}
