package com.example.upbz5.service;

import com.example.upbz5.exception.NotFoundException;
import com.example.upbz5.exception.RegistrationException;
import com.example.upbz5.rest.dto.*;

import java.security.PublicKey;
import java.util.Map;

public interface UserService {

    UserDto registerUser(UserRegistrationRequest registrationRequest) throws RegistrationException;

    UserDto loginUser(UserLoginRequest loginRequest) throws NotFoundException;

    ValidationDto isValidToken(String jwt);

    Long getUserIdByToken(String jwt);

    Map<String, String> encrypt(byte[] data, PublicKey publicKey) throws Exception;

    PublicKey getPublicKeyFromString(String key) throws Exception;

}
