import React from 'react';
import {AppBar, Button, Link, Toolbar, Typography} from '@mui/material';
import {Link as RouterLink, useNavigate} from 'react-router-dom';
import * as PropTypes from "prop-types";
import {getCookie, removeCookie} from "../App";


Button.propTypes = {children: PropTypes.node};
const Navbar = () => {
    const navigate = useNavigate();
    return (
        <AppBar position="fixed">
            <Toolbar>
                <Typography variant="h6" component="div" sx={{flexGrow: 1}}>
                    BookIT
                </Typography>
                {!getCookie('auth') &&
                    <Link component={RouterLink} to="/registration" color="inherit" underline="none" sx={{p: 1}}>
                        Registration
                    </Link>}
                {!getCookie('auth') &&
                    <Link component={RouterLink} to="/signin" color="inherit" underline="none" sx={{p: 1}}>
                        Sign in
                    </Link>}
                {getCookie('auth') &&
                    <Link component={RouterLink} to="/reservations" color="inherit" underline="none" sx={{p: 1}}>
                        Reservations
                    </Link>}
                {getCookie('auth') &&
                    <Link component={RouterLink} to="/accommodation" color="inherit" underline="none" sx={{p: 1}}>
                        Search
                    </Link>}
                {getCookie('auth') &&
                    <Button variant="outlined" style={{color: 'white'}}
                            onClick={() => {
                                removeCookie('auth')
                                navigate('/signin')
                            }}
                    >
                        Sign Out
                    </Button>}
            </Toolbar>
        </AppBar>
    );
};

export default Navbar;
