<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class AddressController extends Controller
{
    protected $user;
    public function __construct(){
        $this->user = auth()->user();
    }

    public function index()
    {
        return response()->json($this->user->addresses, 200);
    }

    public function store(Request $request)
    {
        $address = $this->user->addresses()->create($request->all());
        return response()->json($address, 201);
    }

    public function show($id)
    {
        $address = $this->user->addresses()->find($id);

        if (!$address) {
            return response()->json([
                "message" => "Address not found"
            ], 404);
        }

        return $address;
    }

    public function update(Request $request, $id)
    {
        $address = $this->user->addresses()->find($id);

        if (!$address) {
            return response()->json([
                "message" => "Address not found"
            ], 404);
        }

        $address->update($request->all());
        return response()->json($address, 200);
    }

    public function destroy($id)
    {
        $address = $this->user->addresses()->find($id);

        if (!$address) {
            return response()->json([
                "message" => "Address not found"
            ], 404);
        }

        $address->delete();
        return response()->json([
            "message" => "Address deleted"
        ], 204);
    }
}

