<?php

namespace App\Http\Controllers;

use App\Models\Cart;
use Illuminate\Http\Request;
use App\Models\CartProduct;

class CartController extends Controller
{
    protected $user;

    protected $cart;
    public function __construct()
    {
        $this->user = auth()->user();
    }

    public function index()
    {
        return $this->user->carts;
    }

    public function store(Request $request)
    {
        $cart = $this->user->carts()->create($request->all());
        return response()->json($cart, 201);
    }

    public function update(Request $request)
    {
        $cart = Cart::where('user_id', $this->user->id)->first();
        if (!$cart) {
            $cart = $this->user->carts()->create();
        }
        
        
        if($cart->products()->where('product_id', $request->product_id)->first()){
            
            if($request->quantity == 0){
                $product = $cart->products()->where('product_id', $request->product_id)->first();
                $product->delete();
                $cart = Cart::where('user_id', $this->user->id)->first();
                return response()->json($cart, 201);
            }
            
            $cart->products()->where('product_id', $request->product_id)->update(['quantity' => $request->quantity]);
            return response()->json($cart, 201);
        }
        
        CartProduct::create(
            [
                'cart_id' => $cart->id,
                'product_id' => $request->product_id,
                'quantity' => $request->quantity
            ]
        );
        $cart = Cart::where('user_id', $this->user->id)->first();
        return response()->json($cart, 201);
       
    }

    public function destroy($id)
    {
        $cart = $this->user->carts()->find($id);

        if (!$cart) {
            return response()->json([
                "message" => "Cart not found"
            ], 404);
        }

        $cart->delete();
        return response()->json([
            "message" => "Cart deleted"
        ], 204);
    }

}
