<?php

namespace App\Http\Controllers;

use App\Models\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    public function index()
    {
        return Product::with('images')->with('category')->get();
    }

    public function show($id)
    {
        $product = Product::with('images')->find($id);

        if (!$product) {
            return response()->json([
                "message" => "Product not found"
            ], 404);
        }

        return $product;
    }    

    public function search(Request $request)
    {
        if(!auth()->user()){
            throw new \Exception("Unautorized", 401);
        }

        $query = Product::query();

        if ($request->has('search')) {
            $searchTerm = $request->input('search');
            $query->where('name', 'like', "%$searchTerm%")
                  ->orWhere('description', 'like', "%$searchTerm%");
        }

        $products = $query->get();
        $products = $products->map(function ($product) {
            $product->images;
            return $product;
        });

        return response()->json(['products' => $products]);
    }
}
