<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Rewiew;

class RewiewController extends Controller
{
    protected $user;
    public function __construct()
    {
        $this->user = auth()->user();
    }

    public function index()
    {
        $reviews =  $this->user->rewiews;
        $reviews = $reviews->map(function ($review) {
            $review->product;
            return $review;
        });
        return response()->json($reviews, 200);
    }

    public function store(Request $request)
    {
        $rewiew = $this->user->rewiews()->create($request->all());
        return response()->json($rewiew, 201);
    }

    public function update($id, Request $request)
    {
        $rewiew = $this->user->rewiews()->find($id);

        if (!$rewiew) {
            return response()->json([
                "message" => "Rewiew not found"
            ], 404);
        }

        $rewiew->update($request->all());
        return response()->json($rewiew, 200);
    }

    public function destroy($id)
    {
        $rewiew = $this->user->rewiews()->find($id);

        if (!$rewiew) {
            return response()->json([
                "message" => "Rewiew not found"
            ], 404);
        }

        $rewiew->delete();
        return response()->json([
            "message" => "Rewiew deleted"
        ], 204);
    }

    public function getProductReviews($id)
    {
        $rewiews = Rewiew::where('product_id', $id)
                    ->join('users', 'users.id', '=', 'reviews.user_id')
                    ->select('reviews.*', 'users.first_name')
                    ->get();
                       
        return response()->json($rewiews, 200);
    }
}
