<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Cart extends Model
{
    use HasFactory;
    
    protected $fillable = [
        'user_id',
    ];

    protected $appends = [
        'total_price',
    ];

    public function products()
    {
        return $this->hasMany(CartProduct::class);
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function getTotalPriceAttribute()
    {
        $totalPrice = 0;
        foreach ($this->products as $product) {
            $product->price = $product->product->price;
            $totalPrice += $product->price * $product->quantity;
        }
        return $totalPrice;
    }

    
}
