<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Image extends Model
{
    use HasFactory;

    protected $table = 'product_images';

    protected $fillable = [
            'product_id',
            'image_url',
        ];
    
    protected $appends = [
        'url',
    ];


    public function getUrlAttribute(){
        return url('storage' . '/'. $this->image_url);
    }

    public function product()
    {
        return $this->belongsTo(Product::class);
    }
}
