<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    use HasFactory;
    protected $fillable = [
            'name',
            'slug',
            'description',
            'price',
            'image_url',
            'category_id',
        ];

    protected $appends = [
        'average_rating',
    ];

    public function reviews()
    {
        return $this->hasMany(Rewiew::class);
    }

    public function getAverageRatingAttribute()
    {
        $rating = $this->reviews()->avg('rating');
        return round($rating, 2);
    }
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function images()
    {
        return $this->hasMany(Image::class);
    }

    public function cartProducts()
    {
        return $this->hasMany(CartProduct::class);
    }

    public function orderProducts()
    {
        return $this->hasMany(OrderProduct::class);
    }

    
}
