<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Rewiew extends Model
{
    use HasFactory;

    protected $table = "reviews";
    protected $fillable = [
        'product_id',
        'user_id',
        'rating',
        'text',
    ];

    protected $rules = [
        'rating' => 'required|integer|min:0|max:5',
        'text' => 'required|string|max:200',
    ];

    public function product()
    {
        return $this->belongsTo(Product::class);
    }

    public function user()
    {
        return $this->hasOne(User::class);
    }
}
