<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('banned_passwords', function (Blueprint $table) {
            $table->string('password');
        });

        // insert all passwords from storage file
        $passwords = file_get_contents(storage_path('app/banned_passwords.txt'));
        $passwords = explode("\n", $passwords);
        $passwords = array_map(function ($password) {
            return ['password' => trim($password)];
        }, $passwords);

        DB::table('banned_passwords')->insert($passwords);
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('banned_passwords');
    }
};
