<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('categories', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('slug');
            $table->string('description');
            $table->string('image_url')->nullable();
            $table->timestamps();
        });

        DB::table('categories')->insert(
            array(
                'name' => 'Notebooks',
                'slug' => 'notebooks',
                'description' => 'The best or the worst notebooks in the world',
                'image_url' => 'laptops.jpeg',
            ));

        DB::table('categories')->insert(
            array(
                'name' => 'Smartphones',
                'slug' => 'smartphones',
                'description' => 'Elite of the suteren',
                'image_url' => 'smartphones.png',
            ));
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('categories');
    }
};
