<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('products', function (Blueprint $table) {
            $table->id();
            $table->string('name');
            $table->string('slug')->unique();
            $table->string('description')->nullable();
            $table->foreignId('category_id')->references('id')->on('categories')->nullable();
            $table->decimal('price');
            $table->boolean('available')->default(true);
            $table->unsignedInteger('stock');
            $table->timestamps();
        });

        DB::table('products')->insert(
            array(
                'name' => 'Macbook',
                'slug' => 'macbook-',
                'description' => 'Its something',
                'category_id' => 1,
                'price' => 12,
                'available' => true,
                'stock' => 1000,
            ));
        
        DB::table('products')->insert(
            array(
                'name' => 'Thinkpad',
                'slug' => 'thinkpad',
                'description' => 'Its another thing',
                'category_id' => 1,
                'price' => 13,
                'available' => true,
                'stock' => 1000,
            ));

        DB::table('products')->insert(
            array(
                'name' => 'Iphone',
                'slug' => 'iphone',
                'description' => 'Its something',
                'category_id' => 2,
                'price' => 12000,
                'available' => true,
                'stock' => 1000,
            ));

        DB::table('products')->insert(
            array(
                'name' => 'Samsung',
                'slug' => 'samsung',
                'description' => 'Its another thing',
                'category_id' => 2,
                'price' => 130,
                'available' => true,
                'stock' => 1000,
            ));

    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('products');
    }
};
