<!DOCTYPE html>
<html lang="sk">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Fakturka</title>
<style>
    body {
        font-family: Arial, sans-serif;
        margin: 0;
        padding: 20px;
        background-color: #f4f4f4;
    }
    .invoice-box {
        max-width: 800px;
        margin: auto;
        padding: 30px;
        border: 1px solid #eee;
        box-shadow: 0 0 10px rgba(0, 0, 0, 0.15);
        font-size: 16px;
        line-height: 24px;
        color: #555;
        background-color: #fff;
    }
    .invoice-box table {
        width: 100%;
        line-height: inherit;
        text-align: left;
    }
    .invoice-box table td {
        padding: 5px;
        vertical-align: top;
    }
    .invoice-box table tr td:nth-child(2) {
        text-align: right;
    }
    .invoice-box table tr.top table td {
        padding-bottom: 20px;
    }
    .invoice-box table tr.top table td.title {
        font-size: 45px;
        line-height: 45px;
        color: #333;
    }
    .invoice-box table tr.information table td {
        padding-bottom: 40px;
    }
    .invoice-box table tr.heading td {
        background: #eee;
        border-bottom: 1px solid #ddd;
        font-weight: bold;
    }
    .invoice-box table tr.details td {
        padding-bottom: 20px;
    }
    .invoice-box table tr.item td{
        border-bottom: 1px solid #eee;
    }
    .invoice-box table tr.item.last td {
        border-bottom: none;
    }
    .invoice-box table tr.total td:nth-child(2) {
        border-top: 2px solid #eee;
        font-weight: bold;
    }
    .price {
        text-align: center;
    }
</style>
</head>
<body>
<div class="invoice-box">
    <table cellpadding="0" cellspacing="0">
        <tr class="top">
            <td colspan="4">
                <table>
                    <tr>
                        <td class="title">
                            <h1>UPB Shop</h1>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>

        <tr class="information">
            <td colspan="4">
                <table>
                    <tr>
                        <td>
                            Plebovia z FEI<br>
                            Ilkovičova 3<br>
                            Bratislava
                        </td>

                        <td>
                            <div id="name">{{$order->address->name}} {{$order->address->surname}}</div>
                            <div id="address">{{$order->address->street}}</div>
                            <div id="city">{{$order->address->zip}} {{$order->address->city}}</div>
                            <div id="zip">{{$order->address->country}}</div>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>

        <tr class="heading">
            <td>
                Item
            </td>
            <td class="price">
                Price
            </td>
            <td class="price">
                Quantity
            </td>
            <td class="price">
                Total Price
            </td>
        </tr>

        @foreach($order->products as $product)
        <tr class="item">
            <td class="product-name">
                {{$product->product->name}}
            </td>

            <td class="price">
                {{$product->price}}  €    
            </td>
            <td class="price">
                {{$product->quantity}}
            </td>
            <td class="price">
                {{$product->price * $product->quantity}}  €
            </td>
        </tr>
        @endforeach


        <tr class="total">
            <td></td>
            <td></td>
            <td></td>
            <td>
               Total: <span id="sum">{{$order->total_price}} €</span>
            </td>
        </tr>
    </table>
</div>
</body>
</html>
