const routes = [
  {
    path: '/',
    name: 'products',
    component: () => import('./pages/products/Index.vue'),
  },
  {
    path: '/products/:id',
    name: 'product-detail',
    component: () => import('./pages/products/Detail.vue'),
  },
  {
    path: '/cart',
    name: 'cart',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/Cart.vue'),
  },
  {
    path: '/orders',
    name: 'orders',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/orders/Index.vue'),
  },
  {
    path: '/orders/:id',
    name: 'order-detail',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/orders/Detail.vue'),
  },
  {
    path: '/reviews',
    name: 'reviews',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/reviews/Index.vue'),
  },
  {
    path: '/login',
    name: 'login',
    meta: {
      requiresGuest: true,
    },
    component: () => import('./pages/auth/Login.vue'),
  },
  {
    path: '/register',
    meta: {
      requiresGuest: true,
    },
    component: () => import('./pages/auth/Register.vue'),
  },
  {
    path: '/profile',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/user/Profile.vue'),
  },
  {
    path: '/profile/public-key',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/user/PublicKey.vue'),
  },
  {
    path: '/profile/generate',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/user/PrivateKey.vue'),
  },
  {
    path: '/addresses',
    meta: {
      requiresAuth: true,
    },
    component: () => import('./pages/Addresses.vue'),
  },
  {
    path: '/:pathMatch(.*)*',
    component: () => import('./pages/errors/NotFound.vue'),
  },
]

export default routes
