import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import components from 'unplugin-vue-components/vite'

// https://vitejs.dev/config/
export default defineConfig({
  resolve: {
    alias: {
      '@': '/src',
    },
  },
  plugins: [
    vue(),
    components({
      dts: true,
      resolvers: [
        (name) => {
          if (name.indexOf('Transition') === 0) {
            return {
              name,
              from: '@morev/vue-transitions',
            }
          }
        },
      ],
    }),
  ],
})
